/* MediaUpload.c generated by valac 0.48.17, the Vala compiler
 * generated from MediaUpload.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_MEDIA_UPLOAD (media_upload_get_type ())
#define MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_UPLOAD, MediaUpload))
#define MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_UPLOAD, MediaUploadClass))
#define IS_MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_UPLOAD))
#define IS_MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_UPLOAD))
#define MEDIA_UPLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_UPLOAD, MediaUploadClass))

typedef struct _MediaUpload MediaUpload;
typedef struct _MediaUploadClass MediaUploadClass;
typedef struct _MediaUploadPrivate MediaUploadPrivate;
enum  {
	MEDIA_UPLOAD_0_PROPERTY,
	MEDIA_UPLOAD_ID_PROPERTY,
	MEDIA_UPLOAD_FILEPATH_PROPERTY,
	MEDIA_UPLOAD_FILETYPE_PROPERTY,
	MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY,
	MEDIA_UPLOAD_MEDIA_ID_PROPERTY,
	MEDIA_UPLOAD_FILESIZE_PROPERTY,
	MEDIA_UPLOAD_PROGRESS_PROPERTY,
	MEDIA_UPLOAD_CANCELLABLE_PROPERTY,
	MEDIA_UPLOAD_NUM_PROPERTIES
};
static GParamSpec* media_upload_properties[MEDIA_UPLOAD_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL,
	MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL,
	MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL,
	MEDIA_UPLOAD_NUM_SIGNALS
};
static guint media_upload_signals[MEDIA_UPLOAD_NUM_SIGNALS] = {0};

struct _MediaUpload {
	GObject parent_instance;
	MediaUploadPrivate * priv;
};

struct _MediaUploadClass {
	GObjectClass parent_class;
};

struct _MediaUploadPrivate {
	gchar* _id;
	gchar* cat;
	gint64 _media_id;
	GFile* file;
	GFileInfo* fileinfo;
	gboolean dm;
	gdouble _progress;
	gboolean upload_finalized;
	GCancellable* _cancellable;
};

static gint MediaUpload_private_offset;
static gpointer media_upload_parent_class = NULL;

GType media_upload_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaUpload, g_object_unref)
MediaUpload* media_upload_new (const gchar* filepath,
                               gboolean for_dm,
                               GError** error);
MediaUpload* media_upload_construct (GType object_type,
                                     const gchar* filepath,
                                     gboolean for_dm,
                                     GError** error);
static void media_upload_set_id (MediaUpload* self,
                          const gchar* value);
static void media_upload_set_cancellable (MediaUpload* self,
                                   GCancellable* value);
GFileInputStream* media_upload_read (MediaUpload* self,
                                     GError** error);
void media_upload_finalize_upload (MediaUpload* self);
void media_upload_set_progress (MediaUpload* self,
                                gdouble value);
gboolean media_upload_is_uploaded (MediaUpload* self);
const gchar* media_upload_get_id (MediaUpload* self);
gchar* media_upload_get_filepath (MediaUpload* self);
const gchar* media_upload_get_filetype (MediaUpload* self);
gchar* media_upload_get_media_category (MediaUpload* self);
gboolean utils_is_animated_gif (const gchar* filepath);
gint64 media_upload_get_media_id (MediaUpload* self);
void media_upload_set_media_id (MediaUpload* self,
                                gint64 value);
gint64 media_upload_get_filesize (MediaUpload* self);
gdouble media_upload_get_progress (MediaUpload* self);
GCancellable* media_upload_get_cancellable (MediaUpload* self);
static void media_upload_finalize (GObject * obj);
static GType media_upload_get_type_once (void);
static void _vala_media_upload_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_media_upload_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
media_upload_get_instance_private (MediaUpload* self)
{
	return G_STRUCT_MEMBER_P (self, MediaUpload_private_offset);
}

MediaUpload*
media_upload_construct (GType object_type,
                        const gchar* filepath,
                        gboolean for_dm,
                        GError** error)
{
	MediaUpload * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
	GFileInfo* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (MediaUpload*) g_object_new (object_type, NULL);
	_tmp0_ = g_uuid_string_random ();
	_tmp1_ = _tmp0_;
	media_upload_set_id (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = g_file_new_for_path (filepath);
	_g_object_unref0 (self->priv->file);
	self->priv->file = _tmp2_;
	_tmp4_ = self->priv->file;
	_tmp5_ = g_file_query_info (_tmp4_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE, 0, NULL, &_inner_error0_);
	_tmp3_ = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp6_ = _tmp3_;
	_tmp3_ = NULL;
	_g_object_unref0 (self->priv->fileinfo);
	self->priv->fileinfo = _tmp6_;
	self->priv->dm = for_dm;
	_tmp7_ = g_cancellable_new ();
	_tmp8_ = _tmp7_;
	media_upload_set_cancellable (self, _tmp8_);
	_g_object_unref0 (_tmp8_);
	_g_object_unref0 (_tmp3_);
	return self;
}

MediaUpload*
media_upload_new (const gchar* filepath,
                  gboolean for_dm,
                  GError** error)
{
	return media_upload_construct (TYPE_MEDIA_UPLOAD, filepath, for_dm, error);
}

GFileInputStream*
media_upload_read (MediaUpload* self,
                   GError** error)
{
	GFileInputStream* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileInputStream* _tmp2_;
	GFileInputStream* _tmp3_;
	GError* _inner_error0_ = NULL;
	GFileInputStream* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->file;
	_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp3_;
	_g_object_unref0 (_tmp0_);
	return result;
}

void
media_upload_finalize_upload (MediaUpload* self)
{
	g_return_if_fail (self != NULL);
	g_debug ("MediaUpload.vala:122: Finalizing upload");
	media_upload_set_progress (self, 1.0);
	self->priv->upload_finalized = TRUE;
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL], 0, NULL);
}

gboolean
media_upload_is_uploaded (MediaUpload* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->upload_finalized;
	return result;
}

const gchar*
media_upload_get_id (MediaUpload* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}

static void
media_upload_set_id (MediaUpload* self,
                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_upload_get_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_id);
		self->priv->_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_ID_PROPERTY]);
	}
}

gchar*
media_upload_get_filepath (MediaUpload* self)
{
	gchar* result;
	GFile* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->file;
	_tmp1_ = g_file_get_path (_tmp0_);
	result = _tmp1_;
	return result;
}

const gchar*
media_upload_get_filetype (MediaUpload* self)
{
	const gchar* result;
	GFileInfo* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->fileinfo;
	_tmp1_ = g_file_info_get_content_type (_tmp0_);
	result = _tmp1_;
	return result;
}

gchar*
media_upload_get_media_category (MediaUpload* self)
{
	gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cat;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_ = NULL;
		gchar* prefix = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		if (self->priv->dm) {
			_tmp1_ = "dm";
		} else {
			_tmp1_ = "tweet";
		}
		_tmp2_ = g_strdup (_tmp1_);
		prefix = _tmp2_;
		_tmp3_ = media_upload_get_filetype (self);
		_tmp4_ = _tmp3_;
		if (g_str_has_prefix (_tmp4_, "video/")) {
			const gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp5_ = prefix;
			_tmp6_ = g_strdup_printf ("%s_video", _tmp5_);
			_g_free0 (self->priv->cat);
			self->priv->cat = _tmp6_;
		} else {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			_tmp7_ = media_upload_get_filetype (self);
			_tmp8_ = _tmp7_;
			if (g_strcmp0 (_tmp8_, "image/gif") == 0) {
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_;
				_tmp9_ = media_upload_get_filepath (self);
				_tmp10_ = _tmp9_;
				_tmp11_ = _tmp10_;
				_tmp12_ = utils_is_animated_gif (_tmp11_);
				_g_free0 (_tmp11_);
				if (_tmp12_) {
					const gchar* _tmp13_;
					gchar* _tmp14_;
					_tmp13_ = prefix;
					_tmp14_ = g_strdup_printf ("%s_gif", _tmp13_);
					_g_free0 (self->priv->cat);
					self->priv->cat = _tmp14_;
				} else {
					const gchar* _tmp15_;
					gchar* _tmp16_;
					_tmp15_ = prefix;
					_tmp16_ = g_strdup_printf ("%s_image", _tmp15_);
					_g_free0 (self->priv->cat);
					self->priv->cat = _tmp16_;
				}
			} else {
				const gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp17_ = prefix;
				_tmp18_ = g_strdup_printf ("%s_image", _tmp17_);
				_g_free0 (self->priv->cat);
				self->priv->cat = _tmp18_;
			}
		}
		_g_free0 (prefix);
	}
	_tmp19_ = self->priv->cat;
	_tmp20_ = g_strdup (_tmp19_);
	result = _tmp20_;
	return result;
}

gint64
media_upload_get_media_id (MediaUpload* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_media_id;
	return result;
}

void
media_upload_set_media_id (MediaUpload* self,
                           gint64 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_media_id = value;
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_MEDIA_ID_PROPERTY]);
}

gint64
media_upload_get_filesize (MediaUpload* self)
{
	gint64 result;
	GFileInfo* _tmp0_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->fileinfo;
	result = g_file_info_get_size (_tmp0_);
	return result;
}

gdouble
media_upload_get_progress (MediaUpload* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_progress;
	return result;
}

void
media_upload_set_progress (MediaUpload* self,
                           gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_progress = value;
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL], 0, self->priv->_progress);
	g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_PROGRESS_PROPERTY]);
}

GCancellable*
media_upload_get_cancellable (MediaUpload* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cancellable;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
media_upload_set_cancellable (MediaUpload* self,
                              GCancellable* value)
{
	GCancellable* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_upload_get_cancellable (self);
	if (old_value != value) {
		GCancellable* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_cancellable);
		self->priv->_cancellable = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_CANCELLABLE_PROPERTY]);
	}
}

static void
media_upload_class_init (MediaUploadClass * klass,
                         gpointer klass_data)
{
	media_upload_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MediaUpload_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_media_upload_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_upload_set_property;
	G_OBJECT_CLASS (klass)->finalize = media_upload_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_ID_PROPERTY, media_upload_properties[MEDIA_UPLOAD_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILEPATH_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILEPATH_PROPERTY] = g_param_spec_string ("filepath", "filepath", "filepath", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILETYPE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILETYPE_PROPERTY] = g_param_spec_string ("filetype", "filetype", "filetype", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY, media_upload_properties[MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY] = g_param_spec_string ("media-category", "media-category", "media-category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_MEDIA_ID_PROPERTY, media_upload_properties[MEDIA_UPLOAD_MEDIA_ID_PROPERTY] = g_param_spec_int64 ("media-id", "media-id", "media-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILESIZE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILESIZE_PROPERTY] = g_param_spec_int64 ("filesize", "filesize", "filesize", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_PROGRESS_PROPERTY, media_upload_properties[MEDIA_UPLOAD_PROGRESS_PROPERTY] = g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_CANCELLABLE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	media_upload_signals[MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL] = g_signal_new ("progress-updated", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	media_upload_signals[MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL] = g_signal_new ("progress-complete", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	media_upload_signals[MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL] = g_signal_new ("media-id-assigned", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
media_upload_instance_init (MediaUpload * self,
                            gpointer klass)
{
	self->priv = media_upload_get_instance_private (self);
	self->priv->_media_id = (gint64) -1;
	self->priv->_progress = (gdouble) 0;
}

static void
media_upload_finalize (GObject * obj)
{
	MediaUpload * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_UPLOAD, MediaUpload);
	_g_free0 (self->priv->_id);
	_g_free0 (self->priv->cat);
	_g_object_unref0 (self->priv->file);
	_g_object_unref0 (self->priv->fileinfo);
	_g_object_unref0 (self->priv->_cancellable);
	G_OBJECT_CLASS (media_upload_parent_class)->finalize (obj);
}

static GType
media_upload_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaUploadClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_upload_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaUpload), 0, (GInstanceInitFunc) media_upload_instance_init, NULL };
	GType media_upload_type_id;
	media_upload_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaUpload", &g_define_type_info, 0);
	MediaUpload_private_offset = g_type_add_instance_private (media_upload_type_id, sizeof (MediaUploadPrivate));
	return media_upload_type_id;
}

GType
media_upload_get_type (void)
{
	static volatile gsize media_upload_type_id__volatile = 0;
	if (g_once_init_enter (&media_upload_type_id__volatile)) {
		GType media_upload_type_id;
		media_upload_type_id = media_upload_get_type_once ();
		g_once_init_leave (&media_upload_type_id__volatile, media_upload_type_id);
	}
	return media_upload_type_id__volatile;
}

static void
_vala_media_upload_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MediaUpload * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_UPLOAD, MediaUpload);
	switch (property_id) {
		case MEDIA_UPLOAD_ID_PROPERTY:
		g_value_set_string (value, media_upload_get_id (self));
		break;
		case MEDIA_UPLOAD_FILEPATH_PROPERTY:
		g_value_take_string (value, media_upload_get_filepath (self));
		break;
		case MEDIA_UPLOAD_FILETYPE_PROPERTY:
		g_value_set_string (value, media_upload_get_filetype (self));
		break;
		case MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY:
		g_value_take_string (value, media_upload_get_media_category (self));
		break;
		case MEDIA_UPLOAD_MEDIA_ID_PROPERTY:
		g_value_set_int64 (value, media_upload_get_media_id (self));
		break;
		case MEDIA_UPLOAD_FILESIZE_PROPERTY:
		g_value_set_int64 (value, media_upload_get_filesize (self));
		break;
		case MEDIA_UPLOAD_PROGRESS_PROPERTY:
		g_value_set_double (value, media_upload_get_progress (self));
		break;
		case MEDIA_UPLOAD_CANCELLABLE_PROPERTY:
		g_value_set_object (value, media_upload_get_cancellable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_media_upload_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MediaUpload * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_UPLOAD, MediaUpload);
	switch (property_id) {
		case MEDIA_UPLOAD_ID_PROPERTY:
		media_upload_set_id (self, g_value_get_string (value));
		break;
		case MEDIA_UPLOAD_MEDIA_ID_PROPERTY:
		media_upload_set_media_id (self, g_value_get_int64 (value));
		break;
		case MEDIA_UPLOAD_PROGRESS_PROPERTY:
		media_upload_set_progress (self, g_value_get_double (value));
		break;
		case MEDIA_UPLOAD_CANCELLABLE_PROPERTY:
		media_upload_set_cancellable (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

