/* Settings.c generated by valac 0.48.17, the Vala compiler
 * generated from Settings.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include "CbTextTransform.h"

typedef enum  {
	MEDIA_VISIBILITY_SHOW = 1,
	MEDIA_VISIBILITY_HIDE = 2,
	MEDIA_VISIBILITY_HIDE_IN_TIMELINES = 3
} MediaVisibility;

#define TYPE_MEDIA_VISIBILITY (media_visibility_get_type ())
typedef enum  {
	TRANSLATION_SERVICE_GOOGLE = 0,
	TRANSLATION_SERVICE_BING = 1,
	TRANSLATION_SERVICE_DEEPL = 2,
	TRANSLATION_SERVICE_CUSTOM = 3
} TranslationService;

#define TYPE_TRANSLATION_SERVICE (translation_service_get_type ())
typedef enum  {
	SHORTCUT_KEY_ALT = 0,
	SHORTCUT_KEY_CTRL = 1,
	SHORTCUT_KEY_SHIFT = 2,
	SHORTCUT_KEY_SUPER = 3,
	SHORTCUT_KEY_PRIMARY = 4
} ShortcutKey;

#define TYPE_SHORTCUT_KEY (shortcut_key_get_type ())

#define TYPE_SETTINGS (settings_get_type ())
#define SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS, Settings))
#define SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS, SettingsClass))
#define IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS))
#define IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS))
#define SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS, SettingsClass))

typedef struct _Settings Settings;
typedef struct _SettingsClass SettingsClass;
typedef struct _SettingsPrivate SettingsPrivate;
enum  {
	SETTINGS_0_PROPERTY,
	SETTINGS_NUM_PROPERTIES
};
static GParamSpec* settings_properties[SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Settings {
	GObject parent_instance;
	SettingsPrivate * priv;
};

struct _SettingsClass {
	GObjectClass parent_class;
};

static gpointer settings_parent_class = NULL;
static GSettings* settings_settings;
static GSettings* settings_settings = NULL;

GType media_visibility_get_type (void) G_GNUC_CONST;
GType translation_service_get_type (void) G_GNUC_CONST;
GType shortcut_key_get_type (void) G_GNUC_CONST;
GType settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Settings, g_object_unref)
void settings_init (void);
GSettings* settings_get (void);
gint settings_get_tweet_stack_count (void);
gboolean settings_use_dark_theme (void);
gboolean settings_notify_new_mentions (void);
gboolean settings_notify_new_dms (void);
gboolean settings_auto_scroll_on_new_tweets (void);
gchar* settings_get_accel (const gchar* accel_name);
gdouble settings_get_tweet_scale (void);
void settings_toggle_topbar_visible (void);
gchar* settings_get_consumer_key (const gchar* default_key);
gchar* settings_get_consumer_secret (const gchar* default_secret);
void settings_add_text_transform_flag (CbTransformFlags flag);
void settings_remove_text_transform_flag (CbTransformFlags flag);
CbTransformFlags settings_get_text_transform_flags (void);
gboolean settings_hide_nsfw_content (void);
MediaVisibility settings_get_media_visiblity (void);
TranslationService settings_get_translation_service (void);
gchar* settings_get_custom_translation_service (void);
void settings_set_custom_translation_service (const gchar* new_url);
gchar* settings_get_translation_service_url (void);
ShortcutKey settings_get_shortcut_key (void);
gchar* settings_get_shortcut_key_string (void);
Settings* settings_new (void);
Settings* settings_construct (GType object_type);
static void settings_finalize (GObject * obj);
static GType settings_get_type_once (void);

static GType
media_visibility_get_type_once (void)
{
	static const GEnumValue values[] = {{MEDIA_VISIBILITY_SHOW, "MEDIA_VISIBILITY_SHOW", "show"}, {MEDIA_VISIBILITY_HIDE, "MEDIA_VISIBILITY_HIDE", "hide"}, {MEDIA_VISIBILITY_HIDE_IN_TIMELINES, "MEDIA_VISIBILITY_HIDE_IN_TIMELINES", "hide-in-timelines"}, {0, NULL, NULL}};
	GType media_visibility_type_id;
	media_visibility_type_id = g_enum_register_static ("MediaVisibility", values);
	return media_visibility_type_id;
}

GType
media_visibility_get_type (void)
{
	static volatile gsize media_visibility_type_id__volatile = 0;
	if (g_once_init_enter (&media_visibility_type_id__volatile)) {
		GType media_visibility_type_id;
		media_visibility_type_id = media_visibility_get_type_once ();
		g_once_init_leave (&media_visibility_type_id__volatile, media_visibility_type_id);
	}
	return media_visibility_type_id__volatile;
}

static GType
translation_service_get_type_once (void)
{
	static const GEnumValue values[] = {{TRANSLATION_SERVICE_GOOGLE, "TRANSLATION_SERVICE_GOOGLE", "google"}, {TRANSLATION_SERVICE_BING, "TRANSLATION_SERVICE_BING", "bing"}, {TRANSLATION_SERVICE_DEEPL, "TRANSLATION_SERVICE_DEEPL", "deepl"}, {TRANSLATION_SERVICE_CUSTOM, "TRANSLATION_SERVICE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType translation_service_type_id;
	translation_service_type_id = g_enum_register_static ("TranslationService", values);
	return translation_service_type_id;
}

GType
translation_service_get_type (void)
{
	static volatile gsize translation_service_type_id__volatile = 0;
	if (g_once_init_enter (&translation_service_type_id__volatile)) {
		GType translation_service_type_id;
		translation_service_type_id = translation_service_get_type_once ();
		g_once_init_leave (&translation_service_type_id__volatile, translation_service_type_id);
	}
	return translation_service_type_id__volatile;
}

static GType
shortcut_key_get_type_once (void)
{
	static const GEnumValue values[] = {{SHORTCUT_KEY_ALT, "SHORTCUT_KEY_ALT", "alt"}, {SHORTCUT_KEY_CTRL, "SHORTCUT_KEY_CTRL", "ctrl"}, {SHORTCUT_KEY_SHIFT, "SHORTCUT_KEY_SHIFT", "shift"}, {SHORTCUT_KEY_SUPER, "SHORTCUT_KEY_SUPER", "super"}, {SHORTCUT_KEY_PRIMARY, "SHORTCUT_KEY_PRIMARY", "primary"}, {0, NULL, NULL}};
	GType shortcut_key_type_id;
	shortcut_key_type_id = g_enum_register_static ("ShortcutKey", values);
	return shortcut_key_type_id;
}

GType
shortcut_key_get_type (void)
{
	static volatile gsize shortcut_key_type_id__volatile = 0;
	if (g_once_init_enter (&shortcut_key_type_id__volatile)) {
		GType shortcut_key_type_id;
		shortcut_key_type_id = shortcut_key_get_type_once ();
		g_once_init_leave (&shortcut_key_type_id__volatile, shortcut_key_type_id);
	}
	return shortcut_key_type_id__volatile;
}

void
settings_init (void)
{
	GSettings* _tmp0_;
	_tmp0_ = g_settings_new ("uk.co.ibboard.cawbird");
	_g_object_unref0 (settings_settings);
	settings_settings = _tmp0_;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GSettings*
settings_get (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* result = NULL;
	_tmp0_ = settings_settings;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
   * Returns how many tweets should be stacked before a
   * notification should be created.
   */
gint
settings_get_tweet_stack_count (void)
{
	gint setting_val = 0;
	GSettings* _tmp0_;
	gint result = 0;
	_tmp0_ = settings_settings;
	setting_val = g_settings_get_enum (_tmp0_, "new-tweets-notify");
	result = setting_val;
	return result;
}

/**
  * Check whether the user wants Cawbird to always use the dark gtk theme variant.
  */
gboolean
settings_use_dark_theme (void)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "use-dark-theme");
	return result;
}

gboolean
settings_notify_new_mentions (void)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "new-mentions-notify");
	return result;
}

gboolean
settings_notify_new_dms (void)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "new-dms-notify");
	return result;
}

gboolean
settings_auto_scroll_on_new_tweets (void)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "auto-scroll-on-new-tweets");
	return result;
}

gchar*
settings_get_accel (const gchar* accel_name)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (accel_name != NULL, NULL);
	_tmp0_ = settings_settings;
	_tmp1_ = g_strconcat ("accel-", accel_name, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_settings_get_string (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gdouble
settings_get_tweet_scale (void)
{
	gint scale_idx = 0;
	GSettings* _tmp0_;
	gdouble result = 0.0;
	_tmp0_ = settings_settings;
	scale_idx = g_settings_get_enum (_tmp0_, "tweet-scale");
	switch (scale_idx) {
		case 3:
		{
			result = PANGO_SCALE_XX_LARGE;
			return result;
		}
		case 2:
		{
			result = PANGO_SCALE_X_LARGE;
			return result;
		}
		case 1:
		{
			result = PANGO_SCALE_LARGE;
			return result;
		}
		default:
		{
			result = PANGO_SCALE_MEDIUM;
			return result;
		}
	}
}

void
settings_toggle_topbar_visible (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_boolean (_tmp0_, "sidebar-visible", !g_settings_get_boolean (_tmp1_, "sidebar-visible"));
}

gchar*
settings_get_consumer_key (const gchar* default_key)
{
	gchar* override_key = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (default_key != NULL, NULL);
	_tmp0_ = settings_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-key");
	override_key = _tmp1_;
	_tmp3_ = override_key;
	if (g_strcmp0 (_tmp3_, "") != 0) {
		const gchar* _tmp4_;
		_tmp4_ = override_key;
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = default_key;
	}
	_tmp5_ = g_strdup (_tmp2_);
	result = _tmp5_;
	_g_free0 (override_key);
	return result;
}

gchar*
settings_get_consumer_secret (const gchar* default_secret)
{
	gchar* override_secret = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (default_secret != NULL, NULL);
	_tmp0_ = settings_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-secret");
	override_secret = _tmp1_;
	_tmp3_ = override_secret;
	if (g_strcmp0 (_tmp3_, "") != 0) {
		const gchar* _tmp4_;
		_tmp4_ = override_secret;
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = default_secret;
	}
	_tmp5_ = g_strdup (_tmp2_);
	result = _tmp5_;
	_g_free0 (override_secret);
	return result;
}

void
settings_add_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") | flag);
}

void
settings_remove_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") & (~flag));
}

CbTransformFlags
settings_get_text_transform_flags (void)
{
	GSettings* _tmp0_;
	CbTransformFlags result = 0;
	_tmp0_ = settings_settings;
	result = (CbTransformFlags) g_settings_get_uint (_tmp0_, "text-transform-flags");
	return result;
}

gboolean
settings_hide_nsfw_content (void)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "hide-nsfw-content");
	return result;
}

MediaVisibility
settings_get_media_visiblity (void)
{
	GSettings* _tmp0_;
	MediaVisibility result = 0;
	_tmp0_ = settings_settings;
	result = (MediaVisibility) g_settings_get_enum (_tmp0_, "media-visibility");
	return result;
}

TranslationService
settings_get_translation_service (void)
{
	GSettings* _tmp0_;
	TranslationService result = 0;
	_tmp0_ = settings_settings;
	result = (TranslationService) g_settings_get_enum (_tmp0_, "translation-service");
	return result;
}

gchar*
settings_get_custom_translation_service (void)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
	_tmp0_ = settings_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "custom-translation-service");
	result = _tmp1_;
	return result;
}

void
settings_set_custom_translation_service (const gchar* new_url)
{
	GSettings* _tmp0_;
	g_return_if_fail (new_url != NULL);
	_tmp0_ = settings_settings;
	g_settings_set_string (_tmp0_, "custom-translation-service", new_url);
}

gchar*
settings_get_translation_service_url (void)
{
	TranslationService translation_service = 0;
	TranslationService _tmp0_;
	gchar* result = NULL;
	translation_service = settings_get_translation_service ();
	_tmp0_ = translation_service;
	switch (_tmp0_) {
		case TRANSLATION_SERVICE_GOOGLE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("https://translate.google.com/?op=translate&sl={SOURCE_LANG}&tl={TARGET" \
"_LANG}&text={CONTENT}");
			result = _tmp1_;
			return result;
		}
		case TRANSLATION_SERVICE_BING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("https://www.bing.com/translator/?from={SOURCE_LANG}&to={TARGET_LANG}&t" \
"ext={CONTENT}");
			result = _tmp2_;
			return result;
		}
		case TRANSLATION_SERVICE_DEEPL:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("https://www.deepl.com/translator#{SOURCE_LANG}/{TARGET_LANG}/{CONTENT}");
			result = _tmp3_;
			return result;
		}
		default:
		{
			gchar* _tmp4_;
			_tmp4_ = settings_get_custom_translation_service ();
			result = _tmp4_;
			return result;
		}
	}
}

ShortcutKey
settings_get_shortcut_key (void)
{
	GSettings* _tmp0_;
	ShortcutKey result = 0;
	_tmp0_ = settings_settings;
	result = (ShortcutKey) g_settings_get_enum (_tmp0_, "shortcut-key");
	return result;
}

gchar*
settings_get_shortcut_key_string (void)
{
	ShortcutKey shortcut_key = 0;
	ShortcutKey _tmp0_;
	gchar* result = NULL;
	shortcut_key = settings_get_shortcut_key ();
	_tmp0_ = shortcut_key;
	switch (_tmp0_) {
		case SHORTCUT_KEY_ALT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("<ALT>");
			result = _tmp1_;
			return result;
		}
		case SHORTCUT_KEY_CTRL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("<CTRL>");
			result = _tmp2_;
			return result;
		}
		case SHORTCUT_KEY_SHIFT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("<SHIFT>");
			result = _tmp3_;
			return result;
		}
		case SHORTCUT_KEY_SUPER:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("<SUPER>");
			result = _tmp4_;
			return result;
		}
		case SHORTCUT_KEY_PRIMARY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("<PRIMARY>");
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("<ALT>");
			result = _tmp6_;
			return result;
		}
	}
}

Settings*
settings_construct (GType object_type)
{
	Settings * self = NULL;
	self = (Settings*) g_object_new (object_type, NULL);
	return self;
}

Settings*
settings_new (void)
{
	return settings_construct (TYPE_SETTINGS);
}

static void
settings_class_init (SettingsClass * klass,
                     gpointer klass_data)
{
	settings_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = settings_finalize;
}

static void
settings_instance_init (Settings * self,
                        gpointer klass)
{
}

static void
settings_finalize (GObject * obj)
{
	Settings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS, Settings);
	G_OBJECT_CLASS (settings_parent_class)->finalize (obj);
}

static GType
settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Settings), 0, (GInstanceInitFunc) settings_instance_init, NULL };
	GType settings_type_id;
	settings_type_id = g_type_register_static (G_TYPE_OBJECT, "Settings", &g_define_type_info, 0);
	return settings_type_id;
}

GType
settings_get_type (void)
{
	static volatile gsize settings_type_id__volatile = 0;
	if (g_once_init_enter (&settings_type_id__volatile)) {
		GType settings_type_id;
		settings_type_id = settings_get_type_once ();
		g_once_init_leave (&settings_type_id__volatile, settings_type_id);
	}
	return settings_type_id__volatile;
}

