/* Collect.c generated by valac 0.48.17, the Vala compiler
 * generated from Collect.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define TYPE_COLLECT (collect_get_type ())
#define COLLECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLLECT, Collect))
#define COLLECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLLECT, CollectClass))
#define IS_COLLECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLLECT))
#define IS_COLLECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLLECT))
#define COLLECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLLECT, CollectClass))

typedef struct _Collect Collect;
typedef struct _CollectClass CollectClass;
typedef struct _CollectPrivate CollectPrivate;
enum  {
	COLLECT_0_PROPERTY,
	COLLECT_DONE_PROPERTY,
	COLLECT_NUM_PROPERTIES
};
static GParamSpec* collect_properties[COLLECT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	COLLECT_FINISHED_SIGNAL,
	COLLECT_NUM_SIGNALS
};
static guint collect_signals[COLLECT_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Collect {
	GObject parent_instance;
	CollectPrivate * priv;
};

struct _CollectClass {
	GObjectClass parent_class;
};

struct _CollectPrivate {
	gint cur;
	gint max;
	GError* error;
};

static gint Collect_private_offset;
static gpointer collect_parent_class = NULL;

GType collect_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Collect, g_object_unref)
Collect* collect_new (gint max);
Collect* collect_construct (GType object_type,
                            gint max);
void collect_emit (Collect* self,
                   GError* _error_);
gboolean collect_get_done (Collect* self);
static void collect_finalize (GObject * obj);
static GType collect_get_type_once (void);
static void _vala_collect_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);

static inline gpointer
collect_get_instance_private (Collect* self)
{
	return G_STRUCT_MEMBER_P (self, Collect_private_offset);
}

Collect*
collect_construct (GType object_type,
                   gint max)
{
	Collect * self = NULL;
	_vala_return_val_if_fail (max >= 0, "max >= 0", NULL);
	self = (Collect*) g_object_new (object_type, NULL);
	self->priv->max = max;
	return self;
}

Collect*
collect_new (gint max)
{
	return collect_construct (TYPE_COLLECT, max);
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

void
collect_emit (Collect* self,
              GError* _error_)
{
	GError* _tmp0_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->cur < self->priv->max, "cur < max");
	_tmp0_ = self->priv->error;
	if (_tmp0_ != NULL) {
		return;
	}
	if (_error_ != NULL) {
		GError* _tmp1_;
		g_signal_emit (self, collect_signals[COLLECT_FINISHED_SIGNAL], 0, _error_);
		_tmp1_ = _g_error_copy0 (_error_);
		_g_error_free0 (self->priv->error);
		self->priv->error = _tmp1_;
		return;
	}
	_tmp2_ = self->priv->cur;
	self->priv->cur = _tmp2_ + 1;
	if (self->priv->cur == self->priv->max) {
		g_signal_emit (self, collect_signals[COLLECT_FINISHED_SIGNAL], 0, NULL);
	}
}

gboolean
collect_get_done (Collect* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->cur == self->priv->max;
	return result;
}

static void
collect_class_init (CollectClass * klass,
                    gpointer klass_data)
{
	collect_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Collect_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_collect_get_property;
	G_OBJECT_CLASS (klass)->finalize = collect_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLLECT_DONE_PROPERTY, collect_properties[COLLECT_DONE_PROPERTY] = g_param_spec_boolean ("done", "done", "done", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	collect_signals[COLLECT_FINISHED_SIGNAL] = g_signal_new ("finished", TYPE_COLLECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
}

static void
collect_instance_init (Collect * self,
                       gpointer klass)
{
	self->priv = collect_get_instance_private (self);
	self->priv->cur = 0;
	self->priv->error = NULL;
}

static void
collect_finalize (GObject * obj)
{
	Collect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLLECT, Collect);
	_g_error_free0 (self->priv->error);
	G_OBJECT_CLASS (collect_parent_class)->finalize (obj);
}

static GType
collect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CollectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) collect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Collect), 0, (GInstanceInitFunc) collect_instance_init, NULL };
	GType collect_type_id;
	collect_type_id = g_type_register_static (G_TYPE_OBJECT, "Collect", &g_define_type_info, 0);
	Collect_private_offset = g_type_add_instance_private (collect_type_id, sizeof (CollectPrivate));
	return collect_type_id;
}

GType
collect_get_type (void)
{
	static volatile gsize collect_type_id__volatile = 0;
	if (g_once_init_enter (&collect_type_id__volatile)) {
		GType collect_type_id;
		collect_type_id = collect_get_type_once ();
		g_once_init_leave (&collect_type_id__volatile, collect_type_id);
	}
	return collect_type_id__volatile;
}

static void
_vala_collect_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	Collect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLLECT, Collect);
	switch (property_id) {
		case COLLECT_DONE_PROPERTY:
		g_value_set_boolean (value, collect_get_done (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

