/* InsertStatement.c generated by valac 0.48.17, the Vala compiler
 * generated from InsertStatement.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <sqlite3.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	SQL_INSERT_TYPE_FAIL,
	SQL_INSERT_TYPE_REPLACE,
	SQL_INSERT_TYPE_IGNORE
} SqlInsertType;

#define SQL_TYPE_INSERT_TYPE (sql_insert_type_get_type ())

#define SQL_TYPE_INSERT_STATEMENT (sql_insert_statement_get_type ())
#define SQL_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatement))
#define SQL_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))
#define SQL_IS_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_INSERT_STATEMENT))
#define SQL_IS_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_INSERT_STATEMENT))
#define SQL_INSERT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))

typedef struct _SqlInsertStatement SqlInsertStatement;
typedef struct _SqlInsertStatementClass SqlInsertStatementClass;
typedef struct _SqlInsertStatementPrivate SqlInsertStatementPrivate;
enum  {
	SQL_INSERT_STATEMENT_0_PROPERTY,
	SQL_INSERT_STATEMENT_NUM_PROPERTIES
};
static GParamSpec* sql_insert_statement_properties[SQL_INSERT_STATEMENT_NUM_PROPERTIES];
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SqlInsertStatement {
	GObject parent_instance;
	SqlInsertStatementPrivate * priv;
	sqlite3* db;
};

struct _SqlInsertStatementClass {
	GObjectClass parent_class;
};

struct _SqlInsertStatementPrivate {
	GString* query_builder;
	GPtrArray* bindings;
	gboolean ran;
};

static gint SqlInsertStatement_private_offset;
static gpointer sql_insert_statement_parent_class = NULL;

GType sql_insert_type_get_type (void) G_GNUC_CONST;
GType sql_insert_statement_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlInsertStatement, g_object_unref)
static void _g_free0_ (gpointer var);
SqlInsertStatement* sql_insert_statement_new (const gchar* table_name,
                                              SqlInsertType ins_type);
SqlInsertStatement* sql_insert_statement_construct (GType object_type,
                                                    const gchar* table_name,
                                                    SqlInsertType ins_type);
gint64 sql_insert_statement_run (SqlInsertStatement* self);
SqlInsertStatement* sql_insert_statement_val (SqlInsertStatement* self,
                                              const gchar* col_name,
                                              const gchar* col_value);
SqlInsertStatement* sql_insert_statement_vali (SqlInsertStatement* self,
                                               const gchar* col_name,
                                               gint col_value);
SqlInsertStatement* sql_insert_statement_vali64 (SqlInsertStatement* self,
                                                 const gchar* col_name,
                                                 gint64 col_value);
SqlInsertStatement* sql_insert_statement_valb (SqlInsertStatement* self,
                                               const gchar* col_name,
                                               gboolean col_value);
static void sql_insert_statement_finalize (GObject * obj);
static GType sql_insert_statement_get_type_once (void);

/**
   * What to do in case of key collision during INSERT - fail, replace or ignore
   */
static GType
sql_insert_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SQL_INSERT_TYPE_FAIL, "SQL_INSERT_TYPE_FAIL", "fail"}, {SQL_INSERT_TYPE_REPLACE, "SQL_INSERT_TYPE_REPLACE", "replace"}, {SQL_INSERT_TYPE_IGNORE, "SQL_INSERT_TYPE_IGNORE", "ignore"}, {0, NULL, NULL}};
	GType sql_insert_type_type_id;
	sql_insert_type_type_id = g_enum_register_static ("SqlInsertType", values);
	return sql_insert_type_type_id;
}

GType
sql_insert_type_get_type (void)
{
	static volatile gsize sql_insert_type_type_id__volatile = 0;
	if (g_once_init_enter (&sql_insert_type_type_id__volatile)) {
		GType sql_insert_type_type_id;
		sql_insert_type_type_id = sql_insert_type_get_type_once ();
		g_once_init_leave (&sql_insert_type_type_id__volatile, sql_insert_type_type_id);
	}
	return sql_insert_type_type_id__volatile;
}

static inline gpointer
sql_insert_statement_get_instance_private (SqlInsertStatement* self)
{
	return G_STRUCT_MEMBER_P (self, SqlInsertStatement_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

SqlInsertStatement*
sql_insert_statement_construct (GType object_type,
                                const gchar* table_name,
                                SqlInsertType ins_type)
{
	SqlInsertStatement * self = NULL;
	GString* _tmp3_;
	GString* _tmp4_;
	g_return_val_if_fail (table_name != NULL, NULL);
	self = (SqlInsertStatement*) g_object_new (object_type, NULL);
	if (ins_type == SQL_INSERT_TYPE_REPLACE) {
		GString* _tmp0_;
		_tmp0_ = self->priv->query_builder;
		g_string_append (_tmp0_, "INSERT OR REPLACE INTO `");
	} else {
		if (ins_type == SQL_INSERT_TYPE_IGNORE) {
			GString* _tmp1_;
			_tmp1_ = self->priv->query_builder;
			g_string_append (_tmp1_, "INSERT OR IGNORE INTO `");
		} else {
			GString* _tmp2_;
			_tmp2_ = self->priv->query_builder;
			g_string_append (_tmp2_, "INSERT INTO `");
		}
	}
	_tmp3_ = self->priv->query_builder;
	_tmp4_ = g_string_append (_tmp3_, table_name);
	g_string_append (_tmp4_, "` (");
	return self;
}

SqlInsertStatement*
sql_insert_statement_new (const gchar* table_name,
                          SqlInsertType ins_type)
{
	return sql_insert_statement_construct (SQL_TYPE_INSERT_STATEMENT, table_name, ins_type);
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

gint64
sql_insert_statement_run (SqlInsertStatement* self)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp8_;
	sqlite3_stmt* stmt = NULL;
	gint ok = 0;
	sqlite3* _tmp9_;
	GString* _tmp10_;
	const gchar* _tmp11_;
	sqlite3_stmt* _tmp12_ = NULL;
	gint _tmp13_;
	sqlite3_stmt* _tmp26_;
	sqlite3* _tmp45_;
	gint64 result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->query_builder;
	g_string_append (_tmp0_, ") VALUES (");
	_tmp1_ = self->priv->query_builder;
	g_string_append (_tmp1_, "?");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				GString* _tmp7_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->priv->bindings;
				_tmp5_ = vala_g_ptr_array_get_length (_tmp4_);
				_tmp6_ = _tmp5_;
				if (!(i < (_tmp6_ - 1))) {
					break;
				}
				_tmp7_ = self->priv->query_builder;
				g_string_append (_tmp7_, ",?");
			}
		}
	}
	_tmp8_ = self->priv->query_builder;
	g_string_append (_tmp8_, ");");
	_tmp9_ = self->db;
	_tmp10_ = self->priv->query_builder;
	_tmp11_ = _tmp10_->str;
	_tmp13_ = sqlite3_prepare_v2 (_tmp9_, _tmp11_, -1, &_tmp12_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp12_;
	ok = _tmp13_;
	if (ok != SQLITE_OK) {
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = self->db;
		_tmp15_ = sqlite3_errmsg (_tmp14_);
		g_critical ("InsertStatement.vala:57: %s", _tmp15_);
		result = (gint64) -1;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp16_ = FALSE;
			_tmp16_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				sqlite3_stmt* _tmp21_;
				GPtrArray* _tmp22_;
				gconstpointer _tmp23_;
				gchar* _tmp24_;
				GDestroyNotify _tmp25_;
				if (!_tmp16_) {
					gint _tmp17_;
					_tmp17_ = i;
					i = _tmp17_ + 1;
				}
				_tmp16_ = FALSE;
				_tmp18_ = self->priv->bindings;
				_tmp19_ = vala_g_ptr_array_get_length (_tmp18_);
				_tmp20_ = _tmp19_;
				if (!(i < _tmp20_)) {
					break;
				}
				_tmp21_ = stmt;
				_tmp22_ = self->priv->bindings;
				_tmp23_ = g_ptr_array_index (_tmp22_, (guint) i);
				_tmp24_ = g_strdup ((const gchar*) _tmp23_);
				_tmp25_ = g_free;
				sqlite3_bind_text (_tmp21_, i + 1, _tmp24_, -1, _tmp25_);
			}
		}
	}
	_tmp26_ = stmt;
	ok = sqlite3_step (_tmp26_);
	if (ok != SQLITE_DONE) {
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
		GString* err_msg = NULL;
		GString* _tmp29_;
		GString* _tmp30_;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_;
		GString* _tmp33_;
		GString* _tmp43_;
		const gchar* _tmp44_;
		_tmp27_ = self->db;
		_tmp28_ = sqlite3_errmsg (_tmp27_);
		g_critical ("InsertStatement.vala:66: %s", _tmp28_);
		_tmp29_ = g_string_new ("");
		err_msg = _tmp29_;
		_tmp30_ = err_msg;
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_sql (_tmp31_);
		_tmp33_ = g_string_append (_tmp30_, _tmp32_);
		g_string_append (_tmp33_, " --- ");
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp34_ = FALSE;
				_tmp34_ = TRUE;
				while (TRUE) {
					GPtrArray* _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					GString* _tmp39_;
					GPtrArray* _tmp40_;
					gconstpointer _tmp41_;
					GString* _tmp42_;
					if (!_tmp34_) {
						gint _tmp35_;
						_tmp35_ = i;
						i = _tmp35_ + 1;
					}
					_tmp34_ = FALSE;
					_tmp36_ = self->priv->bindings;
					_tmp37_ = vala_g_ptr_array_get_length (_tmp36_);
					_tmp38_ = _tmp37_;
					if (!(i < _tmp38_)) {
						break;
					}
					_tmp39_ = err_msg;
					_tmp40_ = self->priv->bindings;
					_tmp41_ = g_ptr_array_index (_tmp40_, (guint) i);
					_tmp42_ = g_string_append (_tmp39_, (const gchar*) _tmp41_);
					g_string_append (_tmp42_, ", ");
				}
			}
		}
		_tmp43_ = err_msg;
		_tmp44_ = _tmp43_->str;
		g_critical ("InsertStatement.vala:72: %s", _tmp44_);
		_g_string_free0 (err_msg);
	}
	self->priv->ran = TRUE;
	_tmp45_ = self->db;
	result = sqlite3_last_insert_rowid (_tmp45_);
	_sqlite3_finalize0 (stmt);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

SqlInsertStatement*
sql_insert_statement_val (SqlInsertStatement* self,
                          const gchar* col_name,
                          const gchar* col_value)
{
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GString* _tmp4_;
	GString* _tmp5_;
	GString* _tmp6_;
	GPtrArray* _tmp7_;
	gchar* _tmp8_;
	SqlInsertStatement* _tmp9_;
	SqlInsertStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (col_name != NULL, NULL);
	_tmp0_ = self->priv->bindings;
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		GString* _tmp3_;
		_tmp3_ = self->priv->query_builder;
		g_string_append (_tmp3_, ", ");
	}
	_tmp4_ = self->priv->query_builder;
	_tmp5_ = g_string_append (_tmp4_, "`");
	_tmp6_ = g_string_append (_tmp5_, col_name);
	g_string_append (_tmp6_, "`");
	_tmp7_ = self->priv->bindings;
	_tmp8_ = g_strdup (col_value);
	g_ptr_array_add (_tmp7_, _tmp8_);
	_tmp9_ = _g_object_ref0 (self);
	result = _tmp9_;
	return result;
}

SqlInsertStatement*
sql_insert_statement_vali (SqlInsertStatement* self,
                           const gchar* col_name,
                           gint col_value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	SqlInsertStatement* _tmp2_;
	SqlInsertStatement* _tmp3_;
	SqlInsertStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (col_name != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%i", col_value);
	_tmp1_ = _tmp0_;
	_tmp2_ = sql_insert_statement_val (self, col_name, _tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}

SqlInsertStatement*
sql_insert_statement_vali64 (SqlInsertStatement* self,
                             const gchar* col_name,
                             gint64 col_value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	SqlInsertStatement* _tmp2_;
	SqlInsertStatement* _tmp3_;
	SqlInsertStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (col_name != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, col_value);
	_tmp1_ = _tmp0_;
	_tmp2_ = sql_insert_statement_val (self, col_name, _tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}

SqlInsertStatement*
sql_insert_statement_valb (SqlInsertStatement* self,
                           const gchar* col_name,
                           gboolean col_value)
{
	const gchar* _tmp0_ = NULL;
	SqlInsertStatement* _tmp1_;
	SqlInsertStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (col_name != NULL, NULL);
	if (col_value) {
		_tmp0_ = "1";
	} else {
		_tmp0_ = "0";
	}
	_tmp1_ = sql_insert_statement_val (self, col_name, _tmp0_);
	result = _tmp1_;
	return result;
}

static void
sql_insert_statement_class_init (SqlInsertStatementClass * klass,
                                 gpointer klass_data)
{
	sql_insert_statement_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SqlInsertStatement_private_offset);
	G_OBJECT_CLASS (klass)->finalize = sql_insert_statement_finalize;
}

static void
sql_insert_statement_instance_init (SqlInsertStatement * self,
                                    gpointer klass)
{
	GString* _tmp0_;
	GPtrArray* _tmp1_;
	self->priv = sql_insert_statement_get_instance_private (self);
	_tmp0_ = g_string_new ("");
	self->priv->query_builder = _tmp0_;
	_tmp1_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
	self->priv->bindings = _tmp1_;
	self->priv->ran = FALSE;
}

static void
sql_insert_statement_finalize (GObject * obj)
{
	SqlInsertStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_INSERT_STATEMENT, SqlInsertStatement);
	_g_string_free0 (self->priv->query_builder);
	_g_ptr_array_unref0 (self->priv->bindings);
	G_OBJECT_CLASS (sql_insert_statement_parent_class)->finalize (obj);
}

static GType
sql_insert_statement_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SqlInsertStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sql_insert_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SqlInsertStatement), 0, (GInstanceInitFunc) sql_insert_statement_instance_init, NULL };
	GType sql_insert_statement_type_id;
	sql_insert_statement_type_id = g_type_register_static (G_TYPE_OBJECT, "SqlInsertStatement", &g_define_type_info, 0);
	SqlInsertStatement_private_offset = g_type_add_instance_private (sql_insert_statement_type_id, sizeof (SqlInsertStatementPrivate));
	return sql_insert_statement_type_id;
}

GType
sql_insert_statement_get_type (void)
{
	static volatile gsize sql_insert_statement_type_id__volatile = 0;
	if (g_once_init_enter (&sql_insert_statement_type_id__volatile)) {
		GType sql_insert_statement_type_id;
		sql_insert_statement_type_id = sql_insert_statement_get_type_once ();
		g_once_init_leave (&sql_insert_statement_type_id__volatile, sql_insert_statement_type_id);
	}
	return sql_insert_statement_type_id__volatile;
}

