/* Dirs.c generated by valac 0.48.17, the Vala compiler
 * generated from Dirs.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

extern gchar* dirs_config_dir;
gchar* dirs_config_dir = NULL;
extern gchar* dirs_corebird_config_dir;
gchar* dirs_corebird_config_dir = NULL;

void dirs_create_dirs (void);
void dirs_create_folder (const gchar* path);
gchar* dirs_config (const gchar* path);
gchar* dirs_corebird_config (const gchar* path);
gchar* _dirs_config (const gchar* app_name);

void
dirs_create_dirs (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = dirs_config ("");
	_tmp1_ = _tmp0_;
	dirs_create_folder (_tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = dirs_config ("accounts/");
	_tmp3_ = _tmp2_;
	dirs_create_folder (_tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = dirs_config ("image-favorites/");
	_tmp5_ = _tmp4_;
	dirs_create_folder (_tmp5_);
	_g_free0 (_tmp5_);
}

gchar*
dirs_corebird_config (const gchar* path)
{
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = dirs_corebird_config_dir;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		_tmp1_ = _dirs_config ("corebird");
		_g_free0 (dirs_corebird_config_dir);
		dirs_corebird_config_dir = _tmp1_;
	}
	_tmp2_ = dirs_corebird_config_dir;
	_tmp3_ = g_strconcat (_tmp2_, path, NULL);
	result = _tmp3_;
	return result;
}

gchar*
dirs_config (const gchar* path)
{
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = dirs_config_dir;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		_tmp1_ = _dirs_config ("cawbird");
		_g_free0 (dirs_config_dir);
		dirs_config_dir = _tmp1_;
	}
	_tmp2_ = dirs_config_dir;
	_tmp3_ = g_strconcat (_tmp2_, path, NULL);
	result = _tmp3_;
	return result;
}

gchar*
_dirs_config (const gchar* app_name)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (app_name != NULL, NULL);
	_tmp0_ = g_get_home_dir ();
	_tmp1_ = g_strconcat (_tmp0_, "/.", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, app_name, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "/", NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	dir = _tmp6_;
	_tmp7_ = dir;
	if (!g_file_test (_tmp7_, G_FILE_TEST_EXISTS)) {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp8_ = g_get_user_config_dir ();
		_tmp9_ = g_strconcat (_tmp8_, "/", NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat (_tmp10_, app_name, NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat (_tmp12_, "/", NULL);
		_g_free0 (dir);
		dir = _tmp13_;
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
	}
	result = dir;
	return result;
}

void
dirs_create_folder (const gchar* path)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	if (g_file_test (path, G_FILE_TEST_EXISTS)) {
		return;
	}
	{
		gboolean success = FALSE;
		GFile* _tmp0_;
		GFile* _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = g_file_new_for_path (path);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_make_directory (_tmp1_, NULL, &_inner_error0_);
		_g_object_unref0 (_tmp1_);
		success = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (!success) {
			g_critical ("Dirs.vala:59: Couldn't create user folder %s", path);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("Dirs.vala:62: %s(%s)", _tmp4_, path);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

