/* UserCompletion.c generated by valac 0.48.17, the Vala compiler
 * generated from UserCompletion.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "CbUserCounter.h"
#include <rest/oauth-proxy.h>
#include "CbUserStream.h"
#include "CbFilter.h"
#include <sqlite3.h>

#define TYPE_USER_COMPLETION (user_completion_get_type ())
#define USER_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_COMPLETION, UserCompletion))
#define USER_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_COMPLETION, UserCompletionClass))
#define IS_USER_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_COMPLETION))
#define IS_USER_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_COMPLETION))
#define USER_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_COMPLETION, UserCompletionClass))

typedef struct _UserCompletion UserCompletion;
typedef struct _UserCompletionClass UserCompletionClass;
typedef struct _UserCompletionPrivate UserCompletionPrivate;

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
enum  {
	USER_COMPLETION_0_PROPERTY,
	USER_COMPLETION_NUM_PROPERTIES
};
static GParamSpec* user_completion_properties[USER_COMPLETION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
enum  {
	USER_COMPLETION_START_COMPLETION_SIGNAL,
	USER_COMPLETION_POPULATE_COMPLETION_SIGNAL,
	USER_COMPLETION_NUM_SIGNALS
};
static guint user_completion_signals[USER_COMPLETION_NUM_SIGNALS] = {0};

struct _UserCompletion {
	GObject parent_instance;
	UserCompletionPrivate * priv;
};

struct _UserCompletionClass {
	GObjectClass parent_class;
};

struct _UserCompletionPrivate {
	GObject* obj;
	Account* account;
	gchar* name_property_name;
	gint num_results;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	gint64 id;
	gint64 migration_date;
	gboolean suppress_dm_notifications;
	gboolean suppress_mention_notifications;
	SqlDatabase* db;
	gchar* screen_name;
	gchar* name;
	gchar* avatar_url;
	gchar* banner_url;
	gchar* website;
	gchar* description;
	OAuthProxy* proxy;
	CbUserStream* user_stream;
	CbUserCounter* user_counter;
	NotificationManager* notifications;
	gint64* friends;
	gint friends_length1;
	gint64* blocked;
	gint blocked_length1;
	gint64* muted;
	gint muted_length1;
	gint64* disabled_rts;
	gint disabled_rts_length1;
	GPtrArray* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};

static gint UserCompletion_private_offset;
static gpointer user_completion_parent_class = NULL;

GType user_completion_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UserCompletion, g_object_unref)
GType account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Account, g_object_unref)
UserCompletion* user_completion_new (Account* account,
                                     gint num_results);
UserCompletion* user_completion_construct (GType object_type,
                                           Account* account,
                                           gint num_results);
void user_completion_connect_to (UserCompletion* self,
                                 GObject* obj,
                                 const gchar* name_property_name);
static void user_completion_prop_changed (UserCompletion* self);
static void _user_completion_prop_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
GType sql_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlDatabase, g_object_unref)
GType notification_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationManager, g_object_unref)
sqlite3* sql_database_get_sqlite_db (SqlDatabase* self);
static void _vala_CbUserInfo_array_free (CbUserInfo * array,
                                  gint array_length);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void user_completion_finalize (GObject * obj);
static GType user_completion_get_type_once (void);

static inline gpointer
user_completion_get_instance_private (UserCompletion* self)
{
	return G_STRUCT_MEMBER_P (self, UserCompletion_private_offset);
}

UserCompletion*
user_completion_construct (GType object_type,
                           Account* account,
                           gint num_results)
{
	UserCompletion * self = NULL;
	g_return_val_if_fail (account != NULL, NULL);
	self = (UserCompletion*) g_object_new (object_type, NULL);
	self->priv->account = account;
	self->priv->num_results = num_results;
	return self;
}

UserCompletion*
user_completion_new (Account* account,
                     gint num_results)
{
	return user_completion_construct (TYPE_USER_COMPLETION, account, num_results);
}

static void
_user_completion_prop_changed_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	user_completion_prop_changed ((UserCompletion*) self);
}

void
user_completion_connect_to (UserCompletion* self,
                            GObject* obj,
                            const gchar* name_property_name)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (name_property_name != NULL);
	self->priv->obj = obj;
	_tmp0_ = g_strdup (name_property_name);
	_g_free0 (self->priv->name_property_name);
	self->priv->name_property_name = _tmp0_;
	_tmp1_ = g_strconcat ("notify::", name_property_name, NULL);
	g_signal_connect_object (obj, _tmp1_, (GCallback) _user_completion_prop_changed_g_object_notify, self, 0);
	_g_free0 (_tmp1_);
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static void
_vala_CbUserInfo_array_free (CbUserInfo * array,
                             gint array_length)
{
	if (array != NULL) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			cb_user_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
user_completion_prop_changed (UserCompletion* self)
{
	gchar* name = NULL;
	GObject* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	CbUserInfo* names = NULL;
	gint names_length1 = 0;
	gint _names_size_ = 0;
	Account* _tmp6_;
	CbUserCounter* _tmp7_;
	Account* _tmp8_;
	SqlDatabase* _tmp9_;
	sqlite3* _tmp10_;
	const gchar* _tmp11_;
	CbUserInfo* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->obj;
	_tmp1_ = self->priv->name_property_name;
	g_object_get (_tmp0_, _tmp1_, &_tmp2_, NULL);
	_g_free0 (name);
	name = _tmp2_;
	_tmp3_ = name;
	if (g_str_has_prefix (_tmp3_, "@")) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = name;
		_tmp5_ = string_substring (_tmp4_, (glong) 1, (glong) -1);
		_g_free0 (name);
		name = _tmp5_;
	}
	g_signal_emit (self, user_completion_signals[USER_COMPLETION_START_COMPLETION_SIGNAL], 0);
	_tmp6_ = self->priv->account;
	_tmp7_ = _tmp6_->user_counter;
	_tmp8_ = self->priv->account;
	_tmp9_ = _tmp8_->db;
	_tmp10_ = sql_database_get_sqlite_db (_tmp9_);
	_tmp11_ = name;
	cb_user_counter_query_by_prefix (_tmp7_, _tmp10_, _tmp11_, 10, &_tmp12_, &_tmp13_);
	names = (_vala_CbUserInfo_array_free (names, names_length1), NULL);
	names = _tmp12_;
	names_length1 = _tmp13_;
	_names_size_ = names_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				CbUserInfo* _tmp16_;
				gint _tmp16__length1;
				CbUserInfo* _tmp17_;
				gint _tmp17__length1;
				CbUserInfo _tmp18_;
				const gchar* _tmp19_;
				CbUserInfo* _tmp20_;
				gint _tmp20__length1;
				CbUserInfo _tmp21_;
				const gchar* _tmp22_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = names;
				_tmp16__length1 = names_length1;
				if (!(i < _tmp16__length1)) {
					break;
				}
				_tmp17_ = names;
				_tmp17__length1 = names_length1;
				_tmp18_ = _tmp17_[i];
				_tmp19_ = _tmp18_.screen_name;
				_tmp20_ = names;
				_tmp20__length1 = names_length1;
				_tmp21_ = _tmp20_[i];
				_tmp22_ = _tmp21_.user_name;
				g_signal_emit (self, user_completion_signals[USER_COMPLETION_POPULATE_COMPLETION_SIGNAL], 0, _tmp19_, _tmp22_);
			}
		}
	}
	names = (_vala_CbUserInfo_array_free (names, names_length1), NULL);
	_g_free0 (name);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
user_completion_class_init (UserCompletionClass * klass,
                            gpointer klass_data)
{
	user_completion_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UserCompletion_private_offset);
	G_OBJECT_CLASS (klass)->finalize = user_completion_finalize;
	user_completion_signals[USER_COMPLETION_START_COMPLETION_SIGNAL] = g_signal_new ("start-completion", TYPE_USER_COMPLETION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	user_completion_signals[USER_COMPLETION_POPULATE_COMPLETION_SIGNAL] = g_signal_new ("populate-completion", TYPE_USER_COMPLETION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static void
user_completion_instance_init (UserCompletion * self,
                               gpointer klass)
{
	self->priv = user_completion_get_instance_private (self);
}

static void
user_completion_finalize (GObject * obj)
{
	UserCompletion * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_COMPLETION, UserCompletion);
	_g_free0 (self->priv->name_property_name);
	G_OBJECT_CLASS (user_completion_parent_class)->finalize (obj);
}

static GType
user_completion_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserCompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserCompletion), 0, (GInstanceInitFunc) user_completion_instance_init, NULL };
	GType user_completion_type_id;
	user_completion_type_id = g_type_register_static (G_TYPE_OBJECT, "UserCompletion", &g_define_type_info, 0);
	UserCompletion_private_offset = g_type_add_instance_private (user_completion_type_id, sizeof (UserCompletionPrivate));
	return user_completion_type_id;
}

GType
user_completion_get_type (void)
{
	static volatile gsize user_completion_type_id__volatile = 0;
	if (g_once_init_enter (&user_completion_type_id__volatile)) {
		GType user_completion_type_id;
		user_completion_type_id = user_completion_get_type_once ();
		g_once_init_leave (&user_completion_type_id__volatile, user_completion_type_id);
	}
	return user_completion_type_id__volatile;
}

