/* AvatarWidget.c generated by valac 0.48.17, the Vala compiler
 * generated from AvatarWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_AVATAR_WIDGET (avatar_widget_get_type ())
#define AVATAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AVATAR_WIDGET, AvatarWidget))
#define AVATAR_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AVATAR_WIDGET, AvatarWidgetClass))
#define IS_AVATAR_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AVATAR_WIDGET))
#define IS_AVATAR_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AVATAR_WIDGET))
#define AVATAR_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AVATAR_WIDGET, AvatarWidgetClass))

typedef struct _AvatarWidget AvatarWidget;
typedef struct _AvatarWidgetClass AvatarWidgetClass;
typedef struct _AvatarWidgetPrivate AvatarWidgetPrivate;
enum  {
	AVATAR_WIDGET_0_PROPERTY,
	AVATAR_WIDGET_MAKE_ROUND_PROPERTY,
	AVATAR_WIDGET_VERIFIED_PROPERTY,
	AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY,
	AVATAR_WIDGET_OVERLAP_PROPERTY,
	AVATAR_WIDGET_SIZE_PROPERTY,
	AVATAR_WIDGET_SURFACE_PROPERTY,
	AVATAR_WIDGET_NUM_PROPERTIES
};
static GParamSpec* avatar_widget_properties[AVATAR_WIDGET_NUM_PROPERTIES];

#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AvatarWidget {
	GtkWidget parent_instance;
	AvatarWidgetPrivate * priv;
};

struct _AvatarWidgetClass {
	GtkWidgetClass parent_class;
};

struct _AvatarWidgetPrivate {
	gboolean _round;
	gboolean _verified;
	gboolean _protected_account;
	gboolean _overlap;
	gint _size;
	cairo_surface_t* _surface;
	gdouble alpha;
	gint64 start_time;
};

static gint AvatarWidget_private_offset;
static gpointer avatar_widget_parent_class = NULL;
static cairo_surface_t** avatar_widget_verified_icons;
static gint avatar_widget_verified_icons_length1;
static cairo_surface_t** avatar_widget_verified_icons = NULL;
static gint avatar_widget_verified_icons_length1 = 0;
static gint _avatar_widget_verified_icons_size_ = 0;
static cairo_surface_t** avatar_widget_protected_account_icons;
static gint avatar_widget_protected_account_icons_length1;
static cairo_surface_t** avatar_widget_protected_account_icons = NULL;
static gint avatar_widget_protected_account_icons_length1 = 0;
static gint _avatar_widget_protected_account_icons_size_ = 0;

GType avatar_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AvatarWidget, g_object_unref)
GType twitter_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Twitter, g_object_unref)
Twitter* twitter_get (void);
void twitter_unref_avatar (Twitter* self,
                           cairo_surface_t* surface);
#define AVATAR_WIDGET_SMALL 0
#define AVATAR_WIDGET_LARGE 1
#define AVATAR_WIDGET_OVERLAP_DIST 40
static void avatar_widget_start_animation (AvatarWidget* self);
static gboolean avatar_widget_fade_in_cb (AvatarWidget* self,
                                   GtkWidget* widget,
                                   GdkFrameClock* frame_clock);
static gboolean _avatar_widget_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                      GdkFrameClock* frame_clock,
                                                      gpointer self);
#define TRANSITION_DURATION (200 * 1000)
gdouble ease_out_cubic (gdouble t);
static gboolean avatar_widget_real_draw (GtkWidget* base,
                                  cairo_t* ctx);
gint avatar_widget_get_size (AvatarWidget* self);
gboolean avatar_widget_get_overlap (AvatarWidget* self);
gboolean avatar_widget_get_verified (AvatarWidget* self);
gboolean avatar_widget_get_protected_account (AvatarWidget* self);
static void avatar_widget_real_size_allocate (GtkWidget* base,
                                       GtkAllocation* alloc);
static void avatar_widget_real_get_preferred_width (GtkWidget* base,
                                             gint* min,
                                             gint* nat);
static void avatar_widget_real_get_preferred_height (GtkWidget* base,
                                              gint* min,
                                              gint* nat);
AvatarWidget* avatar_widget_new (void);
AvatarWidget* avatar_widget_construct (GType object_type);
gboolean avatar_widget_get_make_round (AvatarWidget* self);
void avatar_widget_set_make_round (AvatarWidget* self,
                                   gboolean value);
void avatar_widget_set_verified (AvatarWidget* self,
                                 gboolean value);
void avatar_widget_set_protected_account (AvatarWidget* self,
                                          gboolean value);
void avatar_widget_set_overlap (AvatarWidget* self,
                                gboolean value);
void avatar_widget_set_size (AvatarWidget* self,
                             gint value);
cairo_surface_t* avatar_widget_get_surface (AvatarWidget* self);
void avatar_widget_set_surface (AvatarWidget* self,
                                cairo_surface_t* value);
void twitter_ref_avatar (Twitter* self,
                         cairo_surface_t* surface);
static GObject * avatar_widget_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
GSettings* settings_get (void);
static void avatar_widget_finalize (GObject * obj);
static GType avatar_widget_get_type_once (void);
static void _vala_avatar_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_avatar_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gint AVATAR_WIDGET_VERIFIED_SIZES[2] = {12, 25};
static const gint AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[2] = {16, 32};

static inline gpointer
avatar_widget_get_instance_private (AvatarWidget* self)
{
	return G_STRUCT_MEMBER_P (self, AvatarWidget_private_offset);
}

static gboolean
_avatar_widget_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                             GdkFrameClock* frame_clock,
                                             gpointer self)
{
	gboolean result;
	result = avatar_widget_fade_in_cb ((AvatarWidget*) self, widget, frame_clock);
	return result;
}

static void
avatar_widget_start_animation (AvatarWidget* self)
{
	GdkFrameClock* _tmp0_;
	g_return_if_fail (self != NULL);
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
		return;
	}
	self->priv->alpha = 0.0;
	_tmp0_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
	self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp0_);
	gtk_widget_add_tick_callback ((GtkWidget*) self, _avatar_widget_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
}

static gboolean
avatar_widget_fade_in_cb (AvatarWidget* self,
                          GtkWidget* widget,
                          GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (frame_clock != NULL, FALSE);
	now = gdk_frame_clock_get_frame_time (frame_clock);
	t = (now - self->priv->start_time) / ((gdouble) TRANSITION_DURATION);
	if (t >= 1.0) {
		t = 1.0;
	}
	self->priv->alpha = ease_out_cubic (t);
	gtk_widget_queue_draw ((GtkWidget*) self);
	result = t < 1.0;
	return result;
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}

static gboolean
avatar_widget_real_draw (GtkWidget* base,
                         cairo_t* ctx)
{
	AvatarWidget * self;
	gint width = 0;
	gint _tmp0_;
	gint height = 0;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	gdouble surface_scale = 0.0;
	cairo_surface_t* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* ct = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	gdouble scale = 0.0;
	cairo_surface_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	gint y = 0;
	gboolean _tmp16_;
	cairo_surface_t* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp31_;
	gboolean result = FALSE;
	self = (AvatarWidget*) base;
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = self->priv->_size;
	width = _tmp0_;
	_tmp1_ = self->priv->_size;
	height = _tmp1_;
	_tmp2_ = self->priv->_surface;
	if (_tmp2_ == NULL) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	_tmp3_ = self->priv->_surface;
	cairo_surface_get_device_scale (_tmp3_, &_tmp4_, &_tmp5_);
	surface_scale = _tmp4_;
	surface_scale = _tmp5_;
	if (width != height) {
		g_warning ("AvatarWidget.vala:172: Avatar with mapped with width %d and height %d", width, height);
	}
	_tmp6_ = cairo_get_target (ctx);
	_tmp7_ = cairo_surface_create_similar (_tmp6_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
	surface = _tmp7_;
	_tmp8_ = surface;
	_tmp9_ = cairo_create (_tmp8_);
	ct = _tmp9_;
	_tmp10_ = self->priv->_surface;
	scale = ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / ((gdouble) (cairo_image_surface_get_width (_tmp10_) / surface_scale));
	_tmp11_ = ct;
	cairo_rectangle (_tmp11_, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
	_tmp12_ = ct;
	cairo_scale (_tmp12_, scale, scale);
	_tmp13_ = ct;
	_tmp14_ = self->priv->_surface;
	cairo_set_source_surface (_tmp13_, _tmp14_, (gdouble) 0, (gdouble) 0);
	_tmp15_ = ct;
	cairo_fill (_tmp15_);
	_tmp16_ = self->priv->_overlap;
	if (_tmp16_) {
		y = -AVATAR_WIDGET_OVERLAP_DIST;
	} else {
		y = 0;
	}
	if (self->priv->_round) {
		cairo_t* _tmp17_;
		cairo_t* _tmp18_;
		cairo_t* _tmp19_;
		cairo_t* _tmp20_;
		GtkStyleContext* _tmp21_;
		_tmp17_ = ct;
		cairo_scale (_tmp17_, 1.0 / scale, 1.0 / scale);
		_tmp18_ = ct;
		cairo_set_operator (_tmp18_, CAIRO_OPERATOR_DEST_IN);
		_tmp19_ = ct;
		cairo_arc (_tmp19_, width / 2.0, height / 2.0, (width / 2.0) - 0.5, (gdouble) 0, 2 * G_PI);
		_tmp20_ = ct;
		cairo_fill (_tmp20_);
		_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_render_frame (_tmp21_, ctx, (gdouble) 0, (gdouble) y, (gdouble) width, (gdouble) height);
	}
	_tmp22_ = surface;
	cairo_set_source_surface (ctx, _tmp22_, (gdouble) 0, (gdouble) y);
	cairo_paint_with_alpha (ctx, self->priv->alpha);
	_tmp23_ = self->priv->_verified;
	if (_tmp23_) {
		gdouble verified_scale = 0.0;
		gint index = 0;
		gboolean _tmp24_ = FALSE;
		gint _tmp25_ = 0;
		gint scale_factor = 0;
		cairo_surface_t* verified_img = NULL;
		cairo_surface_t** _tmp26_;
		gint _tmp26__length1;
		cairo_surface_t* _tmp27_;
		cairo_surface_t* _tmp28_;
		cairo_surface_t* _tmp29_;
		gint _tmp30_;
		verified_scale = 1.0;
		index = AVATAR_WIDGET_SMALL;
		if (width > 48) {
			index = AVATAR_WIDGET_LARGE;
		}
		if (index == AVATAR_WIDGET_LARGE) {
			_tmp24_ = self->priv->_size < 100;
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			verified_scale = ((gdouble) self->priv->_size) / 100.0;
		}
		if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
			_tmp25_ = 0;
		} else {
			_tmp25_ = 1;
		}
		scale_factor = _tmp25_;
		_tmp26_ = avatar_widget_verified_icons;
		_tmp26__length1 = avatar_widget_verified_icons_length1;
		_tmp27_ = _tmp26_[(scale_factor * 2) + index];
		_tmp28_ = _cairo_surface_reference0 (_tmp27_);
		verified_img = _tmp28_;
		cairo_scale (ctx, verified_scale, verified_scale);
		_tmp29_ = verified_img;
		_tmp30_ = AVATAR_WIDGET_VERIFIED_SIZES[index];
		cairo_set_source_surface (ctx, _tmp29_, (width - (_tmp30_ * verified_scale)) / verified_scale, (gdouble) y);
		cairo_paint_with_alpha (ctx, self->priv->alpha);
		_cairo_surface_destroy0 (verified_img);
	}
	_tmp31_ = self->priv->_protected_account;
	if (_tmp31_) {
		gdouble protected_scale = 0.0;
		gint index = 0;
		gboolean _tmp32_ = FALSE;
		gint _tmp33_ = 0;
		gint scale_factor = 0;
		cairo_surface_t* protected_account_img = NULL;
		cairo_surface_t** _tmp34_;
		gint _tmp34__length1;
		cairo_surface_t* _tmp35_;
		cairo_surface_t* _tmp36_;
		gdouble protected_y = 0.0;
		gint _tmp37_;
		gboolean _tmp38_;
		cairo_surface_t* _tmp39_;
		gint _tmp40_;
		protected_scale = 1.0;
		index = AVATAR_WIDGET_SMALL;
		if (width > 48) {
			index = AVATAR_WIDGET_LARGE;
		}
		if (index == AVATAR_WIDGET_LARGE) {
			_tmp32_ = self->priv->_size < 100;
		} else {
			_tmp32_ = FALSE;
		}
		if (_tmp32_) {
			protected_scale = ((gdouble) self->priv->_size) / 100.0;
		}
		if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
			_tmp33_ = 0;
		} else {
			_tmp33_ = 1;
		}
		scale_factor = _tmp33_;
		_tmp34_ = avatar_widget_protected_account_icons;
		_tmp34__length1 = avatar_widget_protected_account_icons_length1;
		_tmp35_ = _tmp34_[(scale_factor * 2) + index];
		_tmp36_ = _cairo_surface_reference0 (_tmp35_);
		protected_account_img = _tmp36_;
		cairo_scale (ctx, protected_scale, protected_scale);
		_tmp37_ = AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[index];
		protected_y = (height - (_tmp37_ * protected_scale)) / protected_scale;
		_tmp38_ = self->priv->_overlap;
		if (_tmp38_) {
			protected_y -= (gdouble) AVATAR_WIDGET_OVERLAP_DIST;
		}
		_tmp39_ = protected_account_img;
		_tmp40_ = AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[index];
		cairo_set_source_surface (ctx, _tmp39_, (width - (_tmp40_ * protected_scale)) / protected_scale, protected_y);
		cairo_paint_with_alpha (ctx, self->priv->alpha);
		_cairo_surface_destroy0 (protected_account_img);
	}
	result = GDK_EVENT_PROPAGATE;
	_cairo_destroy0 (ct);
	_cairo_surface_destroy0 (surface);
	return result;
}

static void
avatar_widget_real_size_allocate (GtkWidget* base,
                                  GtkAllocation* alloc)
{
	AvatarWidget * self;
	GtkAllocation _tmp0_;
	gboolean _tmp1_;
	self = (AvatarWidget*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	GTK_WIDGET_CLASS (avatar_widget_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), &_tmp0_);
	_tmp1_ = self->priv->_overlap;
	if (_tmp1_) {
		GtkAllocation _tmp2_;
		(*alloc).y = (*alloc).y - AVATAR_WIDGET_OVERLAP_DIST;
		(*alloc).height = (*alloc).height + AVATAR_WIDGET_OVERLAP_DIST;
		_tmp2_ = *alloc;
		gtk_widget_set_clip ((GtkWidget*) self, &_tmp2_);
	}
}

static void
avatar_widget_real_get_preferred_width (GtkWidget* base,
                                        gint* min,
                                        gint* nat)
{
	AvatarWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (AvatarWidget*) base;
	_tmp0_ = self->priv->_size;
	_vala_min = _tmp0_;
	_tmp1_ = self->priv->_size;
	_vala_nat = _tmp1_;
	if (min) {
		*min = _vala_min;
	}
	if (nat) {
		*nat = _vala_nat;
	}
}

static void
avatar_widget_real_get_preferred_height (GtkWidget* base,
                                         gint* min,
                                         gint* nat)
{
	AvatarWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gboolean _tmp0_;
	self = (AvatarWidget*) base;
	_tmp0_ = self->priv->_overlap;
	if (_tmp0_) {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = self->priv->_size;
		_vala_min = _tmp1_ - AVATAR_WIDGET_OVERLAP_DIST;
		_tmp2_ = self->priv->_size;
		_vala_nat = _tmp2_ - AVATAR_WIDGET_OVERLAP_DIST;
	} else {
		gint _tmp3_;
		gint _tmp4_;
		_tmp3_ = self->priv->_size;
		_vala_min = _tmp3_;
		_tmp4_ = self->priv->_size;
		_vala_nat = _tmp4_;
	}
	if (min) {
		*min = _vala_min;
	}
	if (nat) {
		*nat = _vala_nat;
	}
}

AvatarWidget*
avatar_widget_construct (GType object_type)
{
	AvatarWidget * self = NULL;
	self = (AvatarWidget*) gtk_widget_new (object_type, NULL);
	return self;
}

AvatarWidget*
avatar_widget_new (void)
{
	return avatar_widget_construct (TYPE_AVATAR_WIDGET);
}

gboolean
avatar_widget_get_make_round (AvatarWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_round;
	return result;
}

void
avatar_widget_set_make_round (AvatarWidget* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value == self->priv->_round) {
		return;
	}
	if (value) {
		GtkStyleContext* _tmp0_;
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_add_class (_tmp0_, "avatar-round");
	} else {
		GtkStyleContext* _tmp1_;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_remove_class (_tmp1_, "avatar-round");
	}
	self->priv->_round = value;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_MAKE_ROUND_PROPERTY]);
}

gboolean
avatar_widget_get_verified (AvatarWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_verified;
	return result;
}

void
avatar_widget_set_verified (AvatarWidget* self,
                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = avatar_widget_get_verified (self);
	if (old_value != value) {
		self->priv->_verified = value;
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_VERIFIED_PROPERTY]);
	}
}

gboolean
avatar_widget_get_protected_account (AvatarWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_protected_account;
	return result;
}

void
avatar_widget_set_protected_account (AvatarWidget* self,
                                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = avatar_widget_get_protected_account (self);
	if (old_value != value) {
		self->priv->_protected_account = value;
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY]);
	}
}

gboolean
avatar_widget_get_overlap (AvatarWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_overlap;
	return result;
}

void
avatar_widget_set_overlap (AvatarWidget* self,
                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = avatar_widget_get_overlap (self);
	if (old_value != value) {
		self->priv->_overlap = value;
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_OVERLAP_PROPERTY]);
	}
}

gint
avatar_widget_get_size (AvatarWidget* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_size;
	return result;
}

void
avatar_widget_set_size (AvatarWidget* self,
                        gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = avatar_widget_get_size (self);
	if (old_value != value) {
		self->priv->_size = value;
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_SIZE_PROPERTY]);
	}
}

cairo_surface_t*
avatar_widget_get_surface (AvatarWidget* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_surface;
	result = _tmp0_;
	return result;
}

void
avatar_widget_set_surface (AvatarWidget* self,
                           cairo_surface_t* value)
{
	cairo_surface_t* _tmp0_;
	gboolean animate = FALSE;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp5_;
	cairo_surface_t* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_surface;
	if (_tmp0_ == value) {
		return;
	}
	animate = FALSE;
	_tmp1_ = self->priv->_surface;
	if (_tmp1_ != NULL) {
		Twitter* _tmp2_;
		Twitter* _tmp3_;
		cairo_surface_t* _tmp4_;
		_tmp2_ = twitter_get ();
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->_surface;
		twitter_unref_avatar (_tmp3_, _tmp4_);
		_g_object_unref0 (_tmp3_);
	} else {
		animate = TRUE;
	}
	_tmp5_ = _cairo_surface_reference0 ((cairo_surface_t*) value);
	_cairo_surface_destroy0 (self->priv->_surface);
	self->priv->_surface = _tmp5_;
	_tmp6_ = self->priv->_surface;
	if (_tmp6_ != NULL) {
		Twitter* _tmp7_;
		Twitter* _tmp8_;
		cairo_surface_t* _tmp9_;
		_tmp7_ = twitter_get ();
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->_surface;
		twitter_ref_avatar (_tmp8_, _tmp9_);
		_g_object_unref0 (_tmp8_);
		if (animate) {
			avatar_widget_start_animation (self);
		}
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_SURFACE_PROPERTY]);
}

static GObject *
avatar_widget_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AvatarWidget * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	parent_class = G_OBJECT_CLASS (avatar_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_WIDGET, AvatarWidget);
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
	_tmp0_ = settings_get ();
	_tmp1_ = _tmp0_;
	g_settings_bind (_tmp1_, "round-avatars", (GObject*) self, "make_round", G_SETTINGS_BIND_DEFAULT);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp2_, "avatar");
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp3_, "avatar-round");
	return obj;
}

static void
avatar_widget_class_init (AvatarWidgetClass * klass,
                          gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
	avatar_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AvatarWidget_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) avatar_widget_real_draw;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) avatar_widget_real_size_allocate;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) avatar_widget_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) avatar_widget_real_get_preferred_height;
	G_OBJECT_CLASS (klass)->get_property = _vala_avatar_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_avatar_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = avatar_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = avatar_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_MAKE_ROUND_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_MAKE_ROUND_PROPERTY] = g_param_spec_boolean ("make-round", "make-round", "make-round", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_VERIFIED_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_VERIFIED_PROPERTY] = g_param_spec_boolean ("verified", "verified", "verified", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY] = g_param_spec_boolean ("protected-account", "protected-account", "protected-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_OVERLAP_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_OVERLAP_PROPERTY] = g_param_spec_boolean ("overlap", "overlap", "overlap", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_SIZE_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 48, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_SURFACE_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_SURFACE_PROPERTY] = g_param_spec_boxed ("surface", "surface", "surface", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_;
		cairo_surface_t* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		cairo_surface_t* _tmp11_;
		cairo_surface_t** _tmp12_;
		_tmp1_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-small.png", &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-large.png", &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp5_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-small@2.png", &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp2_);
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp7_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-large@2.png", &_inner_error0_);
		_tmp6_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp4_);
			_g_object_unref0 (_tmp2_);
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp8_ = gdk_cairo_surface_create_from_pixbuf (_tmp0_, 1, NULL);
		_tmp9_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 1, NULL);
		_tmp10_ = gdk_cairo_surface_create_from_pixbuf (_tmp4_, 2, NULL);
		_tmp11_ = gdk_cairo_surface_create_from_pixbuf (_tmp6_, 2, NULL);
		_tmp12_ = g_new0 (cairo_surface_t*, 4 + 1);
		_tmp12_[0] = _tmp8_;
		_tmp12_[1] = _tmp9_;
		_tmp12_[2] = _tmp10_;
		_tmp12_[3] = _tmp11_;
		avatar_widget_verified_icons = (_vala_array_free (avatar_widget_verified_icons, avatar_widget_verified_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
		avatar_widget_verified_icons = _tmp12_;
		avatar_widget_verified_icons_length1 = 4;
		_avatar_widget_verified_icons_size_ = avatar_widget_verified_icons_length1;
		_g_object_unref0 (_tmp6_);
		_g_object_unref0 (_tmp4_);
		_g_object_unref0 (_tmp2_);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_critical ("AvatarWidget.vala:98: %s", _tmp14_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	{
		GdkPixbuf* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_;
		GdkPixbuf* _tmp17_ = NULL;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_ = NULL;
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp21_ = NULL;
		GdkPixbuf* _tmp22_;
		cairo_surface_t* _tmp23_;
		cairo_surface_t* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
		cairo_surface_t** _tmp27_;
		_tmp16_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-small.png", &_inner_error0_);
		_tmp15_ = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp18_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-large.png", &_inner_error0_);
		_tmp17_ = _tmp18_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp15_);
			goto __catch1_g_error;
		}
		_tmp20_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-small@2.png", &_inner_error0_);
		_tmp19_ = _tmp20_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp17_);
			_g_object_unref0 (_tmp15_);
			goto __catch1_g_error;
		}
		_tmp22_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-large@2.png", &_inner_error0_);
		_tmp21_ = _tmp22_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp19_);
			_g_object_unref0 (_tmp17_);
			_g_object_unref0 (_tmp15_);
			goto __catch1_g_error;
		}
		_tmp23_ = gdk_cairo_surface_create_from_pixbuf (_tmp15_, 1, NULL);
		_tmp24_ = gdk_cairo_surface_create_from_pixbuf (_tmp17_, 1, NULL);
		_tmp25_ = gdk_cairo_surface_create_from_pixbuf (_tmp19_, 2, NULL);
		_tmp26_ = gdk_cairo_surface_create_from_pixbuf (_tmp21_, 2, NULL);
		_tmp27_ = g_new0 (cairo_surface_t*, 4 + 1);
		_tmp27_[0] = _tmp23_;
		_tmp27_[1] = _tmp24_;
		_tmp27_[2] = _tmp25_;
		_tmp27_[3] = _tmp26_;
		avatar_widget_protected_account_icons = (_vala_array_free (avatar_widget_protected_account_icons, avatar_widget_protected_account_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
		avatar_widget_protected_account_icons = _tmp27_;
		avatar_widget_protected_account_icons_length1 = 4;
		_avatar_widget_protected_account_icons_size_ = avatar_widget_protected_account_icons_length1;
		_g_object_unref0 (_tmp21_);
		_g_object_unref0 (_tmp19_);
		_g_object_unref0 (_tmp17_);
		_g_object_unref0 (_tmp15_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		g_critical ("AvatarWidget.vala:117: %s", _tmp29_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}

static void
avatar_widget_instance_init (AvatarWidget * self,
                             gpointer klass)
{
	self->priv = avatar_widget_get_instance_private (self);
	self->priv->_round = TRUE;
	self->priv->_verified = FALSE;
	self->priv->_protected_account = FALSE;
	self->priv->_overlap = FALSE;
	self->priv->_size = 48;
	self->priv->alpha = (gdouble) 1.0f;
}

static void
avatar_widget_finalize (GObject * obj)
{
	AvatarWidget * self;
	cairo_surface_t* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_WIDGET, AvatarWidget);
	_tmp0_ = self->priv->_surface;
	if (_tmp0_ != NULL) {
		Twitter* _tmp1_;
		Twitter* _tmp2_;
		cairo_surface_t* _tmp3_;
		_tmp1_ = twitter_get ();
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->_surface;
		twitter_unref_avatar (_tmp2_, _tmp3_);
		_g_object_unref0 (_tmp2_);
	}
	_cairo_surface_destroy0 (self->priv->_surface);
	G_OBJECT_CLASS (avatar_widget_parent_class)->finalize (obj);
}

static GType
avatar_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AvatarWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) avatar_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AvatarWidget), 0, (GInstanceInitFunc) avatar_widget_instance_init, NULL };
	GType avatar_widget_type_id;
	avatar_widget_type_id = g_type_register_static (gtk_widget_get_type (), "AvatarWidget", &g_define_type_info, 0);
	AvatarWidget_private_offset = g_type_add_instance_private (avatar_widget_type_id, sizeof (AvatarWidgetPrivate));
	return avatar_widget_type_id;
}

GType
avatar_widget_get_type (void)
{
	static volatile gsize avatar_widget_type_id__volatile = 0;
	if (g_once_init_enter (&avatar_widget_type_id__volatile)) {
		GType avatar_widget_type_id;
		avatar_widget_type_id = avatar_widget_get_type_once ();
		g_once_init_leave (&avatar_widget_type_id__volatile, avatar_widget_type_id);
	}
	return avatar_widget_type_id__volatile;
}

static void
_vala_avatar_widget_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	AvatarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_AVATAR_WIDGET, AvatarWidget);
	switch (property_id) {
		case AVATAR_WIDGET_MAKE_ROUND_PROPERTY:
		g_value_set_boolean (value, avatar_widget_get_make_round (self));
		break;
		case AVATAR_WIDGET_VERIFIED_PROPERTY:
		g_value_set_boolean (value, avatar_widget_get_verified (self));
		break;
		case AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY:
		g_value_set_boolean (value, avatar_widget_get_protected_account (self));
		break;
		case AVATAR_WIDGET_OVERLAP_PROPERTY:
		g_value_set_boolean (value, avatar_widget_get_overlap (self));
		break;
		case AVATAR_WIDGET_SIZE_PROPERTY:
		g_value_set_int (value, avatar_widget_get_size (self));
		break;
		case AVATAR_WIDGET_SURFACE_PROPERTY:
		g_value_set_boxed (value, avatar_widget_get_surface (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_avatar_widget_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	AvatarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_AVATAR_WIDGET, AvatarWidget);
	switch (property_id) {
		case AVATAR_WIDGET_MAKE_ROUND_PROPERTY:
		avatar_widget_set_make_round (self, g_value_get_boolean (value));
		break;
		case AVATAR_WIDGET_VERIFIED_PROPERTY:
		avatar_widget_set_verified (self, g_value_get_boolean (value));
		break;
		case AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY:
		avatar_widget_set_protected_account (self, g_value_get_boolean (value));
		break;
		case AVATAR_WIDGET_OVERLAP_PROPERTY:
		avatar_widget_set_overlap (self, g_value_get_boolean (value));
		break;
		case AVATAR_WIDGET_SIZE_PROPERTY:
		avatar_widget_set_size (self, g_value_get_int (value));
		break;
		case AVATAR_WIDGET_SURFACE_PROPERTY:
		avatar_widget_set_surface (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

