/* CropWidget.c generated by valac 0.48.17, the Vala compiler
 * generated from CropWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <string.h>

#define TYPE_CROP_WIDGET (crop_widget_get_type ())
#define CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_WIDGET, CropWidget))
#define CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_WIDGET, CropWidgetClass))
#define IS_CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_WIDGET))
#define IS_CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_WIDGET))
#define CROP_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_WIDGET, CropWidgetClass))

typedef struct _CropWidget CropWidget;
typedef struct _CropWidgetClass CropWidgetClass;
typedef struct _CropWidgetPrivate CropWidgetPrivate;
enum  {
	CROP_WIDGET_0_PROPERTY,
	CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY,
	CROP_WIDGET_NUM_PROPERTIES
};
static GParamSpec* crop_widget_properties[CROP_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CropWidget {
	GtkDrawingArea parent_instance;
	CropWidgetPrivate * priv;
};

struct _CropWidgetClass {
	GtkDrawingAreaClass parent_class;
};

struct _CropWidgetPrivate {
	GtkGestureDrag* drag_gesture;
	GdkPixbuf* image;
	GdkRectangle selection_rect;
	GdkRectangle image_rect;
	GdkCursor* drag_cursor;
	GdkCursor* default_cursor;
	GdkCursor* resize_cursor;
	gboolean selection_grabbed;
	gboolean resize_area_grabbed;
	gint drag_diff_x;
	gint drag_diff_y;
	gint resize_diff_x;
	gint resize_diff_y;
	gboolean resize_area_hovered;
	gdouble current_scale;
	gint min_width;
	gdouble drag_start_x;
	gdouble drag_start_y;
	gdouble _desired_aspect_ratio;
};

static gint CropWidget_private_offset;
static gpointer crop_widget_parent_class = NULL;

GType crop_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CropWidget, g_object_unref)
#define CROP_WIDGET_MIN_SIZE 48
static gboolean crop_widget_mouse_motion_cb (CropWidget* self,
                                      GdkEventMotion* event);
static gboolean crop_widget_over_resize_area (CropWidget* self,
                                       gdouble x,
                                       gdouble y);
static inline void crop_widget_set_cursor (CropWidget* self,
                             GdkCursor* cursor);
static gboolean crop_widget_cursor_in_selection (CropWidget* self,
                                          gdouble x,
                                          gdouble y);
static void crop_widget_drag_gesture_update_cb (CropWidget* self,
                                         GtkGestureDrag* gesture,
                                         gdouble offset_x,
                                         gdouble offset_y);
static void crop_widget_resize_selection_rect (CropWidget* self,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                        GtkGestureDrag* gesture,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_end_cb (CropWidget* self,
                                      GtkGestureDrag* gesture,
                                      gdouble offset_x,
                                      gdouble offset_y);
static inline void crop_widget_restrict_selection_size (CropWidget* self);
gdouble crop_widget_get_desired_aspect_ratio (CropWidget* self);
void crop_widget_set_image (CropWidget* self,
                            GdkPixbuf* image);
static void crop_widget_calculate_image_rect (CropWidget* self);
static gboolean crop_widget_real_draw (GtkWidget* base,
                                cairo_t* ct);
static void crop_widget_real_size_allocate (GtkWidget* base,
                                     GtkAllocation* alloc);
GdkPixbuf* crop_widget_get_cropped_image (CropWidget* self);
void crop_widget_set_min_size (CropWidget* self,
                               gint min_width);
CropWidget* crop_widget_new (void);
CropWidget* crop_widget_construct (GType object_type);
void crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                           gdouble value);
static GObject * crop_widget_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                      GdkEventMotion* event,
                                                                      gpointer self);
static void _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                     gdouble start_x,
                                                                     gdouble start_y,
                                                                     gpointer self);
static void _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                                 gdouble offset_x,
                                                                 gdouble offset_y,
                                                                 gpointer self);
static void _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                       gdouble offset_x,
                                                                       gdouble offset_y,
                                                                       gpointer self);
static void crop_widget_finalize (GObject * obj);
static GType crop_widget_get_type_once (void);
static void _vala_crop_widget_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_crop_widget_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
crop_widget_get_instance_private (CropWidget* self)
{
	return G_STRUCT_MEMBER_P (self, CropWidget_private_offset);
}

static gboolean
crop_widget_mouse_motion_cb (CropWidget* self,
                             GdkEventMotion* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (crop_widget_over_resize_area (self, event->x, event->y)) {
		GdkCursor* _tmp0_;
		_tmp0_ = self->priv->resize_cursor;
		crop_widget_set_cursor (self, _tmp0_);
		self->priv->resize_area_hovered = TRUE;
		gtk_widget_queue_draw ((GtkWidget*) self);
		result = FALSE;
		return result;
	} else {
		if (self->priv->resize_area_hovered) {
			GdkCursor* _tmp1_;
			self->priv->resize_area_hovered = FALSE;
			_tmp1_ = self->priv->default_cursor;
			crop_widget_set_cursor (self, _tmp1_);
			gtk_widget_queue_draw ((GtkWidget*) self);
		}
	}
	if (crop_widget_cursor_in_selection (self, event->x, event->y)) {
		GdkCursor* _tmp2_;
		_tmp2_ = self->priv->drag_cursor;
		crop_widget_set_cursor (self, _tmp2_);
	} else {
		GdkCursor* _tmp3_;
		_tmp3_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp3_);
	}
	result = FALSE;
	return result;
}

static void
crop_widget_drag_gesture_update_cb (CropWidget* self,
                                    GtkGestureDrag* gesture,
                                    gdouble offset_x,
                                    gdouble offset_y)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	x = self->priv->drag_start_x + offset_x;
	y = self->priv->drag_start_y + offset_y;
	if (self->priv->resize_area_grabbed) {
		crop_widget_resize_selection_rect (self, x, y);
	}
	if (self->priv->selection_grabbed) {
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
		GdkRectangle _tmp9_;
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_;
		GdkRectangle _tmp15_;
		GdkRectangle _tmp16_;
		self->priv->selection_rect.x = ((gint) x) - self->priv->drag_diff_x;
		self->priv->selection_rect.y = ((gint) y) - self->priv->drag_diff_y;
		_tmp0_ = self->priv->selection_rect;
		_tmp1_ = self->priv->image_rect;
		if (_tmp0_.x < _tmp1_.x) {
			GdkRectangle _tmp2_;
			_tmp2_ = self->priv->image_rect;
			self->priv->selection_rect.x = _tmp2_.x;
		}
		_tmp3_ = self->priv->selection_rect;
		_tmp4_ = self->priv->image_rect;
		if (_tmp3_.y < _tmp4_.y) {
			GdkRectangle _tmp5_;
			_tmp5_ = self->priv->image_rect;
			self->priv->selection_rect.y = _tmp5_.y;
		}
		_tmp6_ = self->priv->selection_rect;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = self->priv->image_rect;
		_tmp9_ = self->priv->image_rect;
		if ((_tmp6_.x + _tmp7_.width) > (_tmp8_.x + _tmp9_.width)) {
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
			_tmp10_ = self->priv->image_rect;
			_tmp11_ = self->priv->image_rect;
			_tmp12_ = self->priv->selection_rect;
			self->priv->selection_rect.x = (_tmp10_.x + _tmp11_.width) - _tmp12_.width;
		}
		_tmp13_ = self->priv->selection_rect;
		_tmp14_ = self->priv->selection_rect;
		_tmp15_ = self->priv->image_rect;
		_tmp16_ = self->priv->image_rect;
		if ((_tmp13_.y + _tmp14_.height) > (_tmp15_.y + _tmp16_.height)) {
			GdkRectangle _tmp17_;
			GdkRectangle _tmp18_;
			GdkRectangle _tmp19_;
			_tmp17_ = self->priv->image_rect;
			_tmp18_ = self->priv->image_rect;
			_tmp19_ = self->priv->selection_rect;
			self->priv->selection_rect.y = (_tmp17_.y + _tmp18_.height) - _tmp19_.height;
		}
		gtk_widget_queue_draw ((GtkWidget*) self);
		return;
	}
}

static void
crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                   GtkGestureDrag* gesture,
                                   gdouble x,
                                   gdouble y)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	self->priv->drag_start_x = x;
	self->priv->drag_start_y = y;
	if (crop_widget_over_resize_area (self, x, y)) {
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
		GdkCursor* _tmp4_;
		self->priv->resize_area_grabbed = TRUE;
		_tmp0_ = self->priv->selection_rect;
		_tmp1_ = self->priv->selection_rect;
		self->priv->resize_diff_x = ((gint) x) - (_tmp0_.x + _tmp1_.width);
		_tmp2_ = self->priv->selection_rect;
		_tmp3_ = self->priv->selection_rect;
		self->priv->resize_diff_y = ((gint) y) - (_tmp2_.y + _tmp3_.height);
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
		_tmp4_ = self->priv->resize_cursor;
		crop_widget_set_cursor (self, _tmp4_);
		return;
	}
	if (crop_widget_cursor_in_selection (self, x, y)) {
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
		GdkCursor* _tmp7_;
		self->priv->selection_grabbed = TRUE;
		_tmp5_ = self->priv->selection_rect;
		self->priv->drag_diff_x = (gint) (x - _tmp5_.x);
		_tmp6_ = self->priv->selection_rect;
		self->priv->drag_diff_y = (gint) (y - _tmp6_.y);
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
		_tmp7_ = self->priv->drag_cursor;
		crop_widget_set_cursor (self, _tmp7_);
		return;
	}
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_DENIED);
}

static void
crop_widget_drag_gesture_end_cb (CropWidget* self,
                                 GtkGestureDrag* gesture,
                                 gdouble offset_x,
                                 gdouble offset_y)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	if (self->priv->selection_grabbed) {
		GdkCursor* _tmp0_;
		self->priv->selection_grabbed = FALSE;
		_tmp0_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp0_);
		return;
	}
	if (self->priv->resize_area_grabbed) {
		GdkCursor* _tmp1_;
		self->priv->resize_area_grabbed = FALSE;
		_tmp1_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp1_);
		return;
	}
}

static inline void
crop_widget_restrict_selection_size (CropWidget* self)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
	GdkRectangle _tmp23_;
	GdkRectangle _tmp24_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->selection_rect;
	_tmp1_ = self->priv->image_rect;
	if (_tmp0_.width > _tmp1_.width) {
		GdkRectangle _tmp2_;
		_tmp2_ = self->priv->image_rect;
		self->priv->selection_rect.width = _tmp2_.width;
	}
	_tmp3_ = self->priv->selection_rect;
	_tmp4_ = self->priv->image_rect;
	if (_tmp3_.height > _tmp4_.height) {
		GdkRectangle _tmp5_;
		_tmp5_ = self->priv->image_rect;
		self->priv->selection_rect.height = _tmp5_.height;
	}
	_tmp6_ = self->priv->selection_rect;
	if (((gdouble) _tmp6_.width) < (self->priv->min_width * self->priv->current_scale)) {
		gdouble _tmp7_;
		self->priv->selection_rect.width = (gint) (self->priv->min_width * self->priv->current_scale);
		_tmp7_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.height = (gint) ((self->priv->min_width * self->priv->current_scale) / _tmp7_);
	}
	_tmp8_ = self->priv->selection_rect;
	_tmp9_ = self->priv->image_rect;
	if (_tmp8_.x < _tmp9_.x) {
		GdkRectangle _tmp10_;
		_tmp10_ = self->priv->image_rect;
		self->priv->selection_rect.x = _tmp10_.x;
	}
	_tmp11_ = self->priv->selection_rect;
	_tmp12_ = self->priv->image_rect;
	if (_tmp11_.y < _tmp12_.y) {
		GdkRectangle _tmp13_;
		_tmp13_ = self->priv->image_rect;
		self->priv->selection_rect.y = _tmp13_.y;
	}
	_tmp14_ = self->priv->selection_rect;
	_tmp15_ = self->priv->selection_rect;
	_tmp16_ = self->priv->image_rect;
	_tmp17_ = self->priv->image_rect;
	if ((_tmp14_.x + _tmp15_.width) > (_tmp16_.x + _tmp17_.width)) {
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_;
		_tmp18_ = self->priv->image_rect;
		_tmp19_ = self->priv->image_rect;
		_tmp20_ = self->priv->selection_rect;
		self->priv->selection_rect.x = (_tmp18_.x + _tmp19_.width) - _tmp20_.width;
	}
	_tmp21_ = self->priv->selection_rect;
	_tmp22_ = self->priv->selection_rect;
	_tmp23_ = self->priv->image_rect;
	_tmp24_ = self->priv->image_rect;
	if ((_tmp21_.y + _tmp22_.height) > (_tmp23_.y + _tmp24_.height)) {
		GdkRectangle _tmp25_;
		GdkRectangle _tmp26_;
		GdkRectangle _tmp27_;
		_tmp25_ = self->priv->image_rect;
		_tmp26_ = self->priv->image_rect;
		_tmp27_ = self->priv->selection_rect;
		self->priv->selection_rect.y = (_tmp25_.y + _tmp26_.height) - _tmp27_.height;
	}
}

static void
crop_widget_resize_selection_rect (CropWidget* self,
                                   gdouble x,
                                   gdouble y)
{
	gint max_width = 0;
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	gdouble _tmp3_;
	gint new_width = 0;
	GdkRectangle _tmp4_;
	gint new_height = 0;
	gdouble _tmp5_;
	g_return_if_fail (self != NULL);
	if (!self->priv->resize_area_grabbed) {
		return;
	}
	_tmp0_ = self->priv->image_rect;
	_tmp1_ = self->priv->image_rect;
	_tmp2_ = self->priv->image_rect;
	_tmp3_ = self->priv->_desired_aspect_ratio;
	max_width = MIN (_tmp0_.width, MIN ((gint) _tmp1_.width, (gint) (_tmp2_.height * _tmp3_)));
	_tmp4_ = self->priv->selection_rect;
	new_width = (((gint) x) - _tmp4_.x) - self->priv->resize_diff_x;
	_tmp5_ = self->priv->_desired_aspect_ratio;
	new_height = (gint) (new_width / _tmp5_);
	if (new_width <= max_width) {
		self->priv->selection_rect.width = new_width;
		self->priv->selection_rect.height = new_height;
	} else {
		gdouble _tmp6_;
		self->priv->selection_rect.width = max_width;
		_tmp6_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.height = (gint) (max_width / _tmp6_);
	}
	crop_widget_restrict_selection_size (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
crop_widget_set_image (CropWidget* self,
                       GdkPixbuf* image)
{
	GdkPixbuf* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	gdouble _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (image);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp0_;
	crop_widget_calculate_image_rect (self);
	_tmp1_ = self->priv->image_rect;
	self->priv->selection_rect.width = _tmp1_.width;
	_tmp2_ = self->priv->selection_rect;
	_tmp3_ = self->priv->_desired_aspect_ratio;
	self->priv->selection_rect.height = (gint) (_tmp2_.width / _tmp3_);
	_tmp4_ = self->priv->selection_rect;
	_tmp5_ = self->priv->image_rect;
	if (_tmp4_.height > _tmp5_.height) {
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		gdouble _tmp8_;
		_tmp6_ = self->priv->image_rect;
		self->priv->selection_rect.height = _tmp6_.height;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.width = (gint) (_tmp7_.height * _tmp8_);
	}
	_tmp9_ = self->priv->image_rect;
	_tmp10_ = self->priv->image_rect;
	_tmp11_ = self->priv->selection_rect;
	self->priv->selection_rect.x = _tmp9_.x + ((_tmp10_.width - _tmp11_.width) / 2);
	_tmp12_ = self->priv->image_rect;
	_tmp13_ = self->priv->image_rect;
	_tmp14_ = self->priv->selection_rect;
	self->priv->selection_rect.y = _tmp12_.y + ((_tmp13_.height - _tmp14_.height) / 2);
	crop_widget_restrict_selection_size (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static gboolean
crop_widget_real_draw (GtkWidget* base,
                       cairo_t* ct)
{
	CropWidget * self;
	GdkPixbuf* _tmp0_;
	gint widget_width = 0;
	gint widget_height = 0;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean result = FALSE;
	self = (CropWidget*) base;
	g_return_val_if_fail (ct != NULL, FALSE);
	_tmp0_ = self->priv->image;
	if (_tmp0_ == NULL) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	cairo_set_line_width (ct, 1.0);
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
	cairo_set_source_rgba (ct, 0.3, 0.3, 0.3, 1.0);
	cairo_fill (ct);
	cairo_save (ct);
	_tmp1_ = self->priv->image_rect;
	_tmp2_ = self->priv->image_rect;
	_tmp3_ = self->priv->image_rect;
	_tmp4_ = self->priv->image_rect;
	cairo_rectangle (ct, (gdouble) _tmp1_.x, (gdouble) _tmp2_.y, (gdouble) _tmp3_.width, (gdouble) _tmp4_.height);
	cairo_scale (ct, self->priv->current_scale, self->priv->current_scale);
	_tmp5_ = self->priv->image;
	_tmp6_ = self->priv->image_rect;
	_tmp7_ = self->priv->image_rect;
	gdk_cairo_set_source_pixbuf (ct, _tmp5_, _tmp6_.x / self->priv->current_scale, _tmp7_.y / self->priv->current_scale);
	cairo_fill (ct);
	cairo_restore (ct);
	_tmp8_ = self->priv->selection_rect;
	_tmp9_ = self->priv->selection_rect;
	_tmp10_ = self->priv->selection_rect;
	_tmp11_ = self->priv->selection_rect;
	cairo_rectangle (ct, (gdouble) _tmp8_.x, (gdouble) _tmp9_.y, (gdouble) _tmp10_.width, (gdouble) _tmp11_.height);
	cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 1.0);
	cairo_stroke (ct);
	_tmp12_ = self->priv->selection_rect;
	_tmp13_ = self->priv->selection_rect;
	_tmp14_ = self->priv->selection_rect;
	_tmp15_ = self->priv->selection_rect;
	cairo_rectangle (ct, (gdouble) ((_tmp12_.x + _tmp13_.width) - 15), (gdouble) ((_tmp14_.y + _tmp15_.height) - 15), 14.5, 14.5);
	if (self->priv->resize_area_hovered) {
		_tmp16_ = TRUE;
	} else {
		_tmp16_ = self->priv->resize_area_grabbed;
	}
	if (_tmp16_) {
		cairo_set_source_rgba (ct, 0.0, 0.0, 0.6, 0.7);
	} else {
		cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 0.7);
	}
	cairo_fill (ct);
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static inline void
crop_widget_set_cursor (CropWidget* self,
                        GdkCursor* cursor)
{
	GdkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cursor != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_set_cursor (_tmp0_, cursor);
}

static gboolean
crop_widget_cursor_in_selection (CropWidget* self,
                                 gdouble x,
                                 gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp3_ = self->priv->selection_rect;
	if (x >= ((gdouble) _tmp3_.x)) {
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
		_tmp4_ = self->priv->selection_rect;
		_tmp5_ = self->priv->selection_rect;
		_tmp2_ = x <= ((gdouble) (_tmp4_.x + _tmp5_.width));
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GdkRectangle _tmp6_;
		_tmp6_ = self->priv->selection_rect;
		_tmp1_ = y >= ((gdouble) _tmp6_.y);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = self->priv->selection_rect;
		_tmp0_ = y <= ((gdouble) (_tmp7_.y + _tmp8_.height));
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
crop_widget_real_size_allocate (GtkWidget* base,
                                GtkAllocation* alloc)
{
	CropWidget * self;
	GtkAllocation _tmp0_;
	self = (CropWidget*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	GTK_WIDGET_CLASS (crop_widget_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), &_tmp0_);
	crop_widget_calculate_image_rect (self);
	crop_widget_restrict_selection_size (self);
}

static void
crop_widget_calculate_image_rect (CropWidget* self)
{
	gint widget_width = 0;
	gint widget_height = 0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	g_return_if_fail (self != NULL);
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp0_ = self->priv->image;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->image;
	_tmp2_ = self->priv->image;
	if (gdk_pixbuf_get_width (_tmp1_) > gdk_pixbuf_get_height (_tmp2_)) {
		GdkPixbuf* _tmp3_;
		_tmp3_ = self->priv->image;
		self->priv->current_scale = ((gdouble) widget_width) / gdk_pixbuf_get_width (_tmp3_);
	} else {
		GdkPixbuf* _tmp4_;
		_tmp4_ = self->priv->image;
		self->priv->current_scale = ((gdouble) widget_height) / gdk_pixbuf_get_height (_tmp4_);
	}
	_tmp5_ = self->priv->image;
	if ((gdk_pixbuf_get_width (_tmp5_) * self->priv->current_scale) > ((gdouble) widget_width)) {
		GdkPixbuf* _tmp6_;
		_tmp6_ = self->priv->image;
		self->priv->current_scale = ((gdouble) widget_width) / gdk_pixbuf_get_width (_tmp6_);
	}
	_tmp7_ = self->priv->image;
	if ((gdk_pixbuf_get_height (_tmp7_) * self->priv->current_scale) > ((gdouble) widget_height)) {
		GdkPixbuf* _tmp8_;
		_tmp8_ = self->priv->image;
		self->priv->current_scale = ((gdouble) widget_height) / gdk_pixbuf_get_height (_tmp8_);
	}
	if (self->priv->current_scale > 1.0) {
		self->priv->current_scale = 1.0;
	}
	_tmp9_ = self->priv->image;
	self->priv->image_rect.width = (gint) (gdk_pixbuf_get_width (_tmp9_) * self->priv->current_scale);
	_tmp10_ = self->priv->image;
	self->priv->image_rect.height = (gint) (gdk_pixbuf_get_height (_tmp10_) * self->priv->current_scale);
	_tmp11_ = self->priv->image_rect;
	self->priv->image_rect.x = (widget_width - _tmp11_.width) / 2;
	_tmp12_ = self->priv->image_rect;
	self->priv->image_rect.y = (widget_height - _tmp12_.height) / 2;
}

static gboolean
crop_widget_over_resize_area (CropWidget* self,
                              gdouble x,
                              gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp3_ = self->priv->selection_rect;
	_tmp4_ = self->priv->selection_rect;
	if (x > ((gdouble) ((_tmp3_.x + _tmp4_.width) - 15))) {
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
		_tmp5_ = self->priv->selection_rect;
		_tmp6_ = self->priv->selection_rect;
		_tmp2_ = x < ((gdouble) ((_tmp5_.x + _tmp6_.width) + 5));
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = self->priv->selection_rect;
		_tmp1_ = y > ((gdouble) ((_tmp7_.y + _tmp8_.height) - 15));
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_;
		_tmp9_ = self->priv->selection_rect;
		_tmp10_ = self->priv->selection_rect;
		_tmp0_ = y < ((gdouble) ((_tmp9_.y + _tmp10_.height) + 5));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

GdkPixbuf*
crop_widget_get_cropped_image (CropWidget* self)
{
	gint absolute_x = 0;
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	gint absolute_y = 0;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	gint absolute_w = 0;
	GdkRectangle _tmp4_;
	gint absolute_h = 0;
	GdkRectangle _tmp5_;
	GdkPixbuf* final_image = NULL;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->selection_rect;
	_tmp1_ = self->priv->image_rect;
	absolute_x = (gint) ((_tmp0_.x - _tmp1_.x) / self->priv->current_scale);
	_tmp2_ = self->priv->selection_rect;
	_tmp3_ = self->priv->image_rect;
	absolute_y = (gint) ((_tmp2_.y - _tmp3_.y) / self->priv->current_scale);
	_tmp4_ = self->priv->selection_rect;
	absolute_w = (gint) (_tmp4_.width / self->priv->current_scale);
	_tmp5_ = self->priv->selection_rect;
	absolute_h = (gint) (_tmp5_.height / self->priv->current_scale);
	_tmp6_ = self->priv->image;
	_tmp7_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, gdk_pixbuf_get_has_alpha (_tmp6_), 8, absolute_w, absolute_h);
	final_image = _tmp7_;
	_tmp8_ = self->priv->image;
	gdk_pixbuf_copy_area (_tmp8_, absolute_x, absolute_y, absolute_w, absolute_h, final_image, 0, 0);
	result = final_image;
	return result;
}

void
crop_widget_set_min_size (CropWidget* self,
                          gint min_width)
{
	g_return_if_fail (self != NULL);
	self->priv->min_width = min_width;
}

CropWidget*
crop_widget_construct (GType object_type)
{
	CropWidget * self = NULL;
	self = (CropWidget*) g_object_new (object_type, NULL);
	return self;
}

CropWidget*
crop_widget_new (void)
{
	return crop_widget_construct (TYPE_CROP_WIDGET);
}

gdouble
crop_widget_get_desired_aspect_ratio (CropWidget* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_desired_aspect_ratio;
	return result;
}

void
crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                      gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = crop_widget_get_desired_aspect_ratio (self);
	if (old_value != value) {
		self->priv->_desired_aspect_ratio = value;
		g_object_notify_by_pspec ((GObject *) self, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY]);
	}
}

static gboolean
_crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                             GdkEventMotion* event,
                                                             gpointer self)
{
	gboolean result;
	result = crop_widget_mouse_motion_cb ((CropWidget*) self, event);
	return result;
}

static void
_crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                gdouble start_x,
                                                                gdouble start_y,
                                                                gpointer self)
{
	crop_widget_drag_gesture_begin_cb ((CropWidget*) self, _sender, start_x, start_y);
}

static void
_crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                            gdouble offset_x,
                                                            gdouble offset_y,
                                                            gpointer self)
{
	crop_widget_drag_gesture_end_cb ((CropWidget*) self, _sender, offset_x, offset_y);
}

static void
_crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                  gdouble offset_x,
                                                                  gdouble offset_y,
                                                                  gpointer self)
{
	crop_widget_drag_gesture_update_cb ((CropWidget*) self, _sender, offset_x, offset_y);
}

static GObject *
crop_widget_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CropWidget * self;
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GtkGestureDrag* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkGestureDrag* _tmp8_;
	GtkGestureDrag* _tmp9_;
	GtkGestureDrag* _tmp10_;
	parent_class = G_OBJECT_CLASS (crop_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
	gtk_widget_set_events ((GtkWidget*) self, (((gtk_widget_get_events ((GtkWidget*) self) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON1_MOTION_MASK) | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event, self, 0);
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, GDK_FLEUR);
	_g_object_unref0 (self->priv->drag_cursor);
	self->priv->drag_cursor = _tmp1_;
	_tmp2_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_ARROW);
	_g_object_unref0 (self->priv->default_cursor);
	self->priv->default_cursor = _tmp3_;
	_tmp4_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp5_ = gdk_cursor_new_for_display (_tmp4_, GDK_BOTTOM_RIGHT_CORNER);
	_g_object_unref0 (self->priv->resize_cursor);
	self->priv->resize_cursor = _tmp5_;
	memset (&self->priv->image_rect, 0, sizeof (GdkRectangle));
	memset (&self->priv->selection_rect, 0, sizeof (GdkRectangle));
	_tmp6_ = (GtkGestureDrag*) gtk_gesture_drag_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->drag_gesture);
	self->priv->drag_gesture = _tmp6_;
	_tmp7_ = self->priv->drag_gesture;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp7_, (guint) GDK_BUTTON_PRIMARY);
	_tmp8_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp8_, "drag-begin", (GCallback) _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin, self, 0);
	_tmp9_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp9_, "drag-end", (GCallback) _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end, self, 0);
	_tmp10_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp10_, "drag-update", (GCallback) _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update, self, 0);
	return obj;
}

static void
crop_widget_class_init (CropWidgetClass * klass,
                        gpointer klass_data)
{
	crop_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CropWidget_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) crop_widget_real_draw;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) crop_widget_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_crop_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_crop_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = crop_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = crop_widget_finalize;
	/**
	   * Ratio of the width to the height, i.e. (width/height)
	   * => values >1.0 for landscape pictures
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY] = g_param_spec_double ("desired-aspect-ratio", "desired-aspect-ratio", "desired-aspect-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
crop_widget_instance_init (CropWidget * self,
                           gpointer klass)
{
	self->priv = crop_widget_get_instance_private (self);
	self->priv->selection_grabbed = FALSE;
	self->priv->resize_area_grabbed = FALSE;
	self->priv->drag_diff_x = 0;
	self->priv->drag_diff_y = 0;
	self->priv->resize_diff_x = 0;
	self->priv->resize_diff_y = 0;
	self->priv->resize_area_hovered = FALSE;
	self->priv->current_scale = 1.0;
	self->priv->min_width = CROP_WIDGET_MIN_SIZE;
	self->priv->_desired_aspect_ratio = 0.8;
}

static void
crop_widget_finalize (GObject * obj)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
	_g_object_unref0 (self->priv->drag_gesture);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->drag_cursor);
	_g_object_unref0 (self->priv->default_cursor);
	_g_object_unref0 (self->priv->resize_cursor);
	G_OBJECT_CLASS (crop_widget_parent_class)->finalize (obj);
}

static GType
crop_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CropWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crop_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CropWidget), 0, (GInstanceInitFunc) crop_widget_instance_init, NULL };
	GType crop_widget_type_id;
	crop_widget_type_id = g_type_register_static (gtk_drawing_area_get_type (), "CropWidget", &g_define_type_info, 0);
	CropWidget_private_offset = g_type_add_instance_private (crop_widget_type_id, sizeof (CropWidgetPrivate));
	return crop_widget_type_id;
}

GType
crop_widget_get_type (void)
{
	static volatile gsize crop_widget_type_id__volatile = 0;
	if (g_once_init_enter (&crop_widget_type_id__volatile)) {
		GType crop_widget_type_id;
		crop_widget_type_id = crop_widget_get_type_once ();
		g_once_init_leave (&crop_widget_type_id__volatile, crop_widget_type_id);
	}
	return crop_widget_type_id__volatile;
}

static void
_vala_crop_widget_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
	switch (property_id) {
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
		g_value_set_double (value, crop_widget_get_desired_aspect_ratio (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_crop_widget_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
	switch (property_id) {
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
		crop_widget_set_desired_aspect_ratio (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

