/* MultiMediaWidget.c generated by valac 0.48.17, the Vala compiler
 * generated from MultiMediaWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "CbMedia.h"
#include "CbMediaDownloader.h"
#include <float.h>
#include <math.h>

#define TYPE_MULTI_MEDIA_WIDGET (multi_media_widget_get_type ())
#define MULTI_MEDIA_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget))
#define MULTI_MEDIA_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidgetClass))
#define IS_MULTI_MEDIA_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTI_MEDIA_WIDGET))
#define IS_MULTI_MEDIA_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTI_MEDIA_WIDGET))
#define MULTI_MEDIA_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidgetClass))

typedef struct _MultiMediaWidget MultiMediaWidget;
typedef struct _MultiMediaWidgetClass MultiMediaWidgetClass;
typedef struct _MultiMediaWidgetPrivate MultiMediaWidgetPrivate;

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
enum  {
	MULTI_MEDIA_WIDGET_0_PROPERTY,
	MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY,
	MULTI_MEDIA_WIDGET_NUM_PROPERTIES
};
static GParamSpec* multi_media_widget_properties[MULTI_MEDIA_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MediaButtonPrivate MediaButtonPrivate;
enum  {
	MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL,
	MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL,
	MULTI_MEDIA_WIDGET_NUM_SIGNALS
};
static guint multi_media_widget_signals[MULTI_MEDIA_WIDGET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MultiMediaWidget {
	GtkBox parent_instance;
	MultiMediaWidgetPrivate * priv;
	GtkWindow* window;
};

struct _MultiMediaWidgetClass {
	GtkBoxClass parent_class;
};

struct _MultiMediaWidgetPrivate {
	gboolean __restrict_height;
	MediaButton** media_buttons;
	gint media_buttons_length1;
	gint _media_buttons_size_;
	gint media_count;
	gboolean media_invalid_fired;
};

struct _MediaButton {
	GtkBin parent_instance;
	MediaButtonPrivate * priv;
	GtkWindow* window;
};

struct _MediaButtonClass {
	GtkBinClass parent_class;
};

static gint MultiMediaWidget_private_offset;
static gpointer multi_media_widget_parent_class = NULL;

GType multi_media_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MultiMediaWidget, g_object_unref)
GType media_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaButton, g_object_unref)
#define MULTI_MEDIA_WIDGET_MAX_HEIGHT 180
MultiMediaWidget* multi_media_widget_new (void);
MultiMediaWidget* multi_media_widget_construct (GType object_type);
static void __lambda15_ (MultiMediaWidget* self);
CbMedia* media_button_get_media (MediaButton* self);
static void ___lambda15__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void multi_media_widget_set_all_media (MultiMediaWidget* self,
                                       CbMedia** medias,
                                       gint medias_length1);
static void multi_media_widget_remove_all (MultiMediaWidget* self);
void multi_media_widget_set_media (MultiMediaWidget* self,
                                   gint index,
                                   CbMedia* media);
static void __lambda16_ (MultiMediaWidget* self,
                  GtkWidget* w);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
gboolean multi_media_widget_get_restrict_height (MultiMediaWidget* self);
MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
void media_button_set_media (MediaButton* self,
                             CbMedia* value);
static void multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                         CbMedia* source);
static void _multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                            gpointer self);
static void multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                           MediaButton* source,
                                           gdouble px,
                                           gdouble py);
static void _multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                                 MediaButton* source,
                                                                 gdouble px,
                                                                 gdouble py,
                                                                 gpointer self);
void multi_media_widget_set_restrict_height (MultiMediaWidget* self,
                                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                             GValue * return_value,
                                                             guint n_param_values,
                                                             const GValue * param_values,
                                                             gpointer invocation_hint,
                                                             gpointer marshal_data);
static GObject * multi_media_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void multi_media_widget_finalize (GObject * obj);
static GType multi_media_widget_get_type_once (void);
static void _vala_multi_media_widget_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_multi_media_widget_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
multi_media_widget_get_instance_private (MultiMediaWidget* self)
{
	return G_STRUCT_MEMBER_P (self, MultiMediaWidget_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda15_ (MultiMediaWidget* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				MediaButton** _tmp4_;
				gint _tmp4__length1;
				MediaButton* _tmp5_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < self->priv->media_count)) {
					break;
				}
				_tmp4_ = self->priv->media_buttons;
				_tmp4__length1 = self->priv->media_buttons_length1;
				_tmp5_ = _tmp4_[i];
				if (_tmp5_ != NULL) {
					CbMedia* media = NULL;
					MediaButton** _tmp6_;
					gint _tmp6__length1;
					MediaButton* _tmp7_;
					CbMedia* _tmp8_;
					CbMedia* _tmp9_;
					CbMedia* _tmp10_;
					gboolean _tmp11_ = FALSE;
					CbMedia* _tmp12_;
					_tmp6_ = self->priv->media_buttons;
					_tmp6__length1 = self->priv->media_buttons_length1;
					_tmp7_ = _tmp6_[i];
					_tmp8_ = media_button_get_media (_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = _g_object_ref0 (_tmp9_);
					media = _tmp10_;
					_tmp12_ = media;
					if (!_tmp12_->loaded) {
						CbMedia* _tmp13_;
						_tmp13_ = media;
						_tmp11_ = !_tmp13_->loading;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						CbMediaDownloader* _tmp14_;
						CbMedia* _tmp15_;
						_tmp14_ = cb_media_downloader_get_default ();
						_tmp15_ = media;
						cb_media_downloader_load_async (_tmp14_, _tmp15_, NULL, NULL);
					}
					_g_object_unref0 (media);
				}
			}
		}
	}
}

static void
___lambda15__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda15_ ((MultiMediaWidget*) self);
}

MultiMediaWidget*
multi_media_widget_construct (GType object_type)
{
	MultiMediaWidget * self = NULL;
	self = (MultiMediaWidget*) g_object_new (object_type, NULL);
	g_signal_connect_object ((GObject*) self, "notify::visible", (GCallback) ___lambda15__g_object_notify, self, 0);
	return self;
}

MultiMediaWidget*
multi_media_widget_new (void)
{
	return multi_media_widget_construct (TYPE_MULTI_MEDIA_WIDGET);
}

void
multi_media_widget_set_all_media (MultiMediaWidget* self,
                                  CbMedia** medias,
                                  gint medias_length1)
{
	MediaButton** _tmp0_;
	g_return_if_fail (self != NULL);
	multi_media_widget_remove_all (self);
	_tmp0_ = g_new0 (MediaButton*, medias_length1 + 1);
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->media_buttons = _tmp0_;
	self->priv->media_buttons_length1 = medias_length1;
	self->priv->_media_buttons_size_ = self->priv->media_buttons_length1;
	self->priv->media_count = medias_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				CbMedia* _tmp3_;
				CbMedia* _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < medias_length1)) {
					break;
				}
				_tmp3_ = medias[i];
				_vala_assert (_tmp3_ != NULL, "medias[i] != null");
				_tmp4_ = medias[i];
				multi_media_widget_set_media (self, i, _tmp4_);
			}
		}
	}
}

static void
__lambda16_ (MultiMediaWidget* self,
             GtkWidget* w)
{
	g_return_if_fail (w != NULL);
	gtk_container_remove ((GtkContainer*) self, w);
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda16_ ((MultiMediaWidget*) self, (GtkWidget*) data);
}

static void
multi_media_widget_remove_all (MultiMediaWidget* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda16__gfunc, self);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
}

static void
_multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                       gpointer self)
{
	multi_media_widget_media_loaded_cb ((MultiMediaWidget*) self, _sender);
}

static void
_multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                            MediaButton* source,
                                                            gdouble px,
                                                            gdouble py,
                                                            gpointer self)
{
	multi_media_widget_button_clicked_cb ((MultiMediaWidget*) self, source, px, py);
}

void
multi_media_widget_set_media (MultiMediaWidget* self,
                              gint index,
                              CbMedia* media)
{
	gboolean _tmp0_ = FALSE;
	MediaButton* button = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MediaButton* _tmp3_;
	MediaButton* _tmp4_;
	MediaButton* _tmp5_;
	GtkWindow* _tmp6_;
	MediaButton* _tmp7_;
	MediaButton* _tmp8_;
	MediaButton** _tmp9_;
	gint _tmp9__length1;
	MediaButton* _tmp10_;
	MediaButton* _tmp11_;
	MediaButton* _tmp20_;
	MediaButton* _tmp21_;
	MediaButton* _tmp22_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_vala_assert (index < self->priv->media_count, "index < media_count");
	if (media->loaded) {
		_tmp0_ = media->invalid;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = multi_media_widget_get_restrict_height (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = media_button_new (NULL, _tmp2_);
	g_object_ref_sink (_tmp3_);
	button = _tmp3_;
	_tmp4_ = button;
	g_object_set_data_full ((GObject*) _tmp4_, "pos", (gpointer) ((gintptr) index), NULL);
	_tmp5_ = button;
	_tmp6_ = self->window;
	_tmp5_->window = _tmp6_;
	_tmp7_ = button;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = button;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = self->priv->media_buttons;
	_tmp9__length1 = self->priv->media_buttons_length1;
	_tmp10_ = button;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (_tmp9_[index]);
	_tmp9_[index] = _tmp11_;
	if (media->loaded) {
		MediaButton** _tmp12_;
		gint _tmp12__length1;
		MediaButton* _tmp13_;
		_tmp12_ = self->priv->media_buttons;
		_tmp12__length1 = self->priv->media_buttons_length1;
		_tmp13_ = _tmp12_[index];
		media_button_set_media (_tmp13_, media);
	} else {
		MediaButton** _tmp14_;
		gint _tmp14__length1;
		MediaButton* _tmp15_;
		gboolean _tmp16_ = FALSE;
		_tmp14_ = self->priv->media_buttons;
		_tmp14__length1 = self->priv->media_buttons_length1;
		_tmp15_ = _tmp14_[index];
		media_button_set_media (_tmp15_, media);
		g_signal_connect_object (media, "progress", (GCallback) _multi_media_widget_media_loaded_cb_cb_media_progress, self, 0);
		if (!media->loading) {
			gboolean _tmp17_;
			gboolean _tmp18_;
			_tmp17_ = gtk_widget_get_visible ((GtkWidget*) self);
			_tmp18_ = _tmp17_;
			_tmp16_ = _tmp18_;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			CbMediaDownloader* _tmp19_;
			_tmp19_ = cb_media_downloader_get_default ();
			cb_media_downloader_load_async (_tmp19_, media, NULL, NULL);
		}
	}
	_tmp20_ = button;
	gtk_widget_set_visible ((GtkWidget*) _tmp20_, TRUE);
	_tmp21_ = button;
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) _multi_media_widget_button_clicked_cb_media_button_clicked, self, 0);
	_tmp22_ = button;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp22_, TRUE, TRUE, (guint) 0);
	gtk_widget_queue_draw ((GtkWidget*) self);
	_g_object_unref0 (button);
}

static void
multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                      MediaButton* source,
                                      gdouble px,
                                      gdouble py)
{
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp1_ = media_button_get_media (source);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		CbMedia* _tmp3_;
		CbMedia* _tmp4_;
		_tmp3_ = media_button_get_media (source);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_->loaded;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint index = 0;
		gconstpointer _tmp5_;
		CbMedia* _tmp6_;
		CbMedia* _tmp7_;
		_tmp5_ = g_object_get_data ((GObject*) source, "pos");
		index = (gint) ((gintptr) _tmp5_);
		_tmp6_ = media_button_get_media (source);
		_tmp7_ = _tmp6_;
		g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL], 0, _tmp7_, index, px, py);
	}
}

static void
multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                    CbMedia* source)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	if (source->percent_loaded < ((gdouble) 1)) {
		return;
	}
	if (source->invalid) {
		if (!self->priv->media_invalid_fired) {
			g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL], 0);
			self->priv->media_invalid_fired = TRUE;
		}
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_ = FALSE;
				MediaButton** _tmp3_;
				gint _tmp3__length1;
				MediaButton* _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < self->priv->media_count)) {
					break;
				}
				_tmp3_ = self->priv->media_buttons;
				_tmp3__length1 = self->priv->media_buttons_length1;
				_tmp4_ = _tmp3_[i];
				if (_tmp4_ != NULL) {
					MediaButton** _tmp5_;
					gint _tmp5__length1;
					MediaButton* _tmp6_;
					CbMedia* _tmp7_;
					CbMedia* _tmp8_;
					_tmp5_ = self->priv->media_buttons;
					_tmp5__length1 = self->priv->media_buttons_length1;
					_tmp6_ = _tmp5_[i];
					_tmp7_ = media_button_get_media (_tmp6_);
					_tmp8_ = _tmp7_;
					_tmp2_ = _tmp8_ == source;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					MediaButton** _tmp9_;
					gint _tmp9__length1;
					MediaButton* _tmp10_;
					_tmp9_ = self->priv->media_buttons;
					_tmp9__length1 = self->priv->media_buttons_length1;
					_tmp10_ = _tmp9_[i];
					gtk_widget_queue_draw ((GtkWidget*) _tmp10_);
					break;
				}
			}
		}
	}
}

gboolean
multi_media_widget_get_restrict_height (MultiMediaWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->__restrict_height;
	return result;
}

void
multi_media_widget_set_restrict_height (MultiMediaWidget* self,
                                        gboolean value)
{
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	self->priv->__restrict_height = value;
	if (value) {
		_tmp0_ = MULTI_MEDIA_WIDGET_MAX_HEIGHT;
	} else {
		_tmp0_ = -1;
	}
	gtk_widget_set_size_request ((GtkWidget*) self, -1, _tmp0_);
	g_object_notify_by_pspec ((GObject *) self, multi_media_widget_properties[MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gint arg_2, gdouble arg_3, gdouble arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_double (param_values + 3), g_value_get_double (param_values + 4), data2);
}

static GObject *
multi_media_widget_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MultiMediaWidget * self;
	parent_class = G_OBJECT_CLASS (multi_media_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	gtk_box_set_homogeneous ((GtkBox*) self, TRUE);
	gtk_box_set_spacing ((GtkBox*) self, 2);
	return obj;
}

static void
multi_media_widget_class_init (MultiMediaWidgetClass * klass,
                               gpointer klass_data)
{
	multi_media_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MultiMediaWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_multi_media_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_multi_media_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = multi_media_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = multi_media_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY, multi_media_widget_properties[MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY] = g_param_spec_boolean ("restrict-height", "restrict-height", "restrict-height", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL] = g_signal_new ("media-clicked", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE, G_TYPE_NONE, 4, CB_TYPE_MEDIA, G_TYPE_INT, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL] = g_signal_new ("media-invalid", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
multi_media_widget_instance_init (MultiMediaWidget * self,
                                  gpointer klass)
{
	self->priv = multi_media_widget_get_instance_private (self);
	self->priv->__restrict_height = FALSE;
	self->priv->media_count = 0;
	self->priv->media_invalid_fired = FALSE;
}

static void
multi_media_widget_finalize (GObject * obj)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (multi_media_widget_parent_class)->finalize (obj);
}

static GType
multi_media_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MultiMediaWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multi_media_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultiMediaWidget), 0, (GInstanceInitFunc) multi_media_widget_instance_init, NULL };
	GType multi_media_widget_type_id;
	multi_media_widget_type_id = g_type_register_static (gtk_box_get_type (), "MultiMediaWidget", &g_define_type_info, 0);
	MultiMediaWidget_private_offset = g_type_add_instance_private (multi_media_widget_type_id, sizeof (MultiMediaWidgetPrivate));
	return multi_media_widget_type_id;
}

GType
multi_media_widget_get_type (void)
{
	static volatile gsize multi_media_widget_type_id__volatile = 0;
	if (g_once_init_enter (&multi_media_widget_type_id__volatile)) {
		GType multi_media_widget_type_id;
		multi_media_widget_type_id = multi_media_widget_get_type_once ();
		g_once_init_leave (&multi_media_widget_type_id__volatile, multi_media_widget_type_id);
	}
	return multi_media_widget_type_id__volatile;
}

static void
_vala_multi_media_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	switch (property_id) {
		case MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY:
		g_value_set_boolean (value, multi_media_widget_get_restrict_height (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_multi_media_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	switch (property_id) {
		case MULTI_MEDIA_WIDGET_RESTRICT_HEIGHT_PROPERTY:
		multi_media_widget_set_restrict_height (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

