/* MediaDialog.c generated by valac 0.48.17, the Vala compiler
 * generated from MediaDialog.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "CbMedia.h"
#include <glib.h>
#include <gdk/gdk.h>
#include "CbMediaDownloader.h"
#include <float.h>
#include <math.h>
#include "CbMediaVideoWidget.h"
#include "CbMediaImageWidget.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_MEDIA_DIALOG (media_dialog_get_type ())
#define MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_DIALOG, MediaDialog))
#define MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_DIALOG, MediaDialogClass))
#define IS_MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_DIALOG))
#define IS_MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_DIALOG))
#define MEDIA_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_DIALOG, MediaDialogClass))

typedef struct _MediaDialog MediaDialog;
typedef struct _MediaDialogClass MediaDialogClass;
typedef struct _MediaDialogPrivate MediaDialogPrivate;
enum  {
	MEDIA_DIALOG_0_PROPERTY,
	MEDIA_DIALOG_NUM_PROPERTIES
};
static GParamSpec* media_dialog_properties[MEDIA_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MediaDialog {
	GtkWindow parent_instance;
	MediaDialogPrivate * priv;
};

struct _MediaDialogClass {
	GtkWindowClass parent_class;
};

struct _MediaDialogPrivate {
	GtkFrame* frame;
	GtkRevealer* next_revealer;
	GtkRevealer* previous_revealer;
	GtkRevealer* media_count_revealer;
	GtkLabel* media_count;
	CbMedia** media;
	gint media_length1;
	gint _media_size_;
	gint cur_index;
	GtkGestureMultiPress* button_gesture;
	GdkRectangle max_dimensions;
};

static gint MediaDialog_private_offset;
static gpointer media_dialog_parent_class = NULL;

GType media_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaDialog, g_object_unref)
MediaDialog* media_dialog_new (CbMedia** media,
                               gint media_length1,
                               gint start_media_index,
                               GdkRectangle* max_dimensions);
MediaDialog* media_dialog_construct (GType object_type,
                                     CbMedia** media,
                                     gint media_length1,
                                     gint start_media_index,
                                     GdkRectangle* max_dimensions);
static void media_dialog_button_released_cb (MediaDialog* self,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                        gint n_press,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static void media_dialog_change_media (MediaDialog* self,
                                gint new_index);
static void media_dialog_next_media (MediaDialog* self);
static void media_dialog_previous_media (MediaDialog* self);
static gboolean media_dialog_key_press_event_cb (MediaDialog* self,
                                          GdkEventKey* evt);
static gboolean _media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void media_dialog_next_button_clicked_cb (MediaDialog* self);
static void _media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void media_dialog_previous_button_clicked_cb (MediaDialog* self);
static void _media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static gboolean media_dialog_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean media_dialog_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static void media_dialog_finalize (GObject * obj);
static GType media_dialog_get_type_once (void);

static inline gpointer
media_dialog_get_instance_private (MediaDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MediaDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self)
{
	media_dialog_button_released_cb ((MediaDialog*) self, n_press, x, y);
}

MediaDialog*
media_dialog_construct (GType object_type,
                        CbMedia** media,
                        gint media_length1,
                        gint start_media_index,
                        GdkRectangle* max_dimensions)
{
	MediaDialog * self = NULL;
	CbMediaDownloader* downloader = NULL;
	CbMediaDownloader* _tmp0_;
	CbMediaDownloader* _tmp1_;
	GdkRectangle _tmp8_;
	GtkGestureMultiPress* _tmp9_;
	GtkGestureMultiPress* _tmp10_;
	GtkGestureMultiPress* _tmp11_;
	GtkGestureMultiPress* _tmp12_;
	g_return_val_if_fail (max_dimensions != NULL, NULL);
	self = (MediaDialog*) g_object_new (object_type, NULL);
	self->priv->media = media;
	self->priv->media_length1 = media_length1;
	self->priv->_media_size_ = self->priv->media_length1;
	_tmp0_ = cb_media_downloader_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	downloader = _tmp1_;
	{
		CbMedia** m_collection = NULL;
		gint m_collection_length1 = 0;
		gint _m_collection_size_ = 0;
		gint m_it = 0;
		m_collection = media;
		m_collection_length1 = media_length1;
		for (m_it = 0; m_it < m_collection_length1; m_it = m_it + 1) {
			CbMedia* _tmp2_;
			CbMedia* m = NULL;
			_tmp2_ = _g_object_ref0 (m_collection[m_it]);
			m = _tmp2_;
			{
				gboolean _tmp3_ = FALSE;
				CbMedia* _tmp4_;
				_tmp4_ = m;
				if (!_tmp4_->loaded_hires) {
					CbMedia* _tmp5_;
					_tmp5_ = m;
					_tmp3_ = !_tmp5_->loading_hires;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					CbMediaDownloader* _tmp6_;
					CbMedia* _tmp7_;
					_tmp6_ = downloader;
					_tmp7_ = m;
					cb_media_downloader_load_hires_async (_tmp6_, _tmp7_, NULL, NULL);
				}
				_g_object_unref0 (m);
			}
		}
	}
	self->priv->cur_index = start_media_index;
	_tmp8_ = *max_dimensions;
	self->priv->max_dimensions = _tmp8_;
	_tmp9_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->button_gesture);
	self->priv->button_gesture = _tmp9_;
	_tmp10_ = self->priv->button_gesture;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp10_, (guint) 0);
	_tmp11_ = self->priv->button_gesture;
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp11_, GTK_PHASE_BUBBLE);
	_tmp12_ = self->priv->button_gesture;
	g_signal_connect_object (_tmp12_, "released", (GCallback) _media_dialog_button_released_cb_gtk_gesture_multi_press_released, self, 0);
	if (media_length1 == 1) {
		GtkRevealer* _tmp13_;
		GtkRevealer* _tmp14_;
		GtkRevealer* _tmp15_;
		_tmp13_ = self->priv->next_revealer;
		gtk_widget_hide ((GtkWidget*) _tmp13_);
		_tmp14_ = self->priv->previous_revealer;
		gtk_widget_hide ((GtkWidget*) _tmp14_);
		_tmp15_ = self->priv->media_count_revealer;
		gtk_widget_hide ((GtkWidget*) _tmp15_);
	}
	media_dialog_change_media (self, start_media_index);
	_g_object_unref0 (downloader);
	return self;
}

MediaDialog*
media_dialog_new (CbMedia** media,
                  gint media_length1,
                  gint start_media_index,
                  GdkRectangle* max_dimensions)
{
	return media_dialog_construct (TYPE_MEDIA_DIALOG, media, media_length1, start_media_index, max_dimensions);
}

static void
media_dialog_button_released_cb (MediaDialog* self,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
	GtkGestureMultiPress* _tmp0_;
	g_return_if_fail (self != NULL);
	gtk_widget_destroy ((GtkWidget*) self);
	_tmp0_ = self->priv->button_gesture;
	gtk_gesture_set_state ((GtkGesture*) _tmp0_, GTK_EVENT_SEQUENCE_CLAIMED);
}

static void
media_dialog_change_media (MediaDialog* self,
                           gint new_index)
{
	GtkWidget* cur_child = NULL;
	GtkFrame* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gint cur_width = 0;
	gint cur_height = 0;
	gint new_width = 0;
	gint new_height = 0;
	GtkFrame* _tmp3_;
	GtkWidget* _tmp4_;
	CbMedia* media = NULL;
	CbMedia** _tmp10_;
	gint _tmp10__length1;
	CbMedia* _tmp11_;
	CbMedia* _tmp12_;
	GtkWidget* new_widget = NULL;
	CbMedia* _tmp13_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	GtkLabel* _tmp32_;
	CbMedia** _tmp33_;
	gint _tmp33__length1;
	CbMedia** _tmp34_;
	gint _tmp34__length1;
	gchar* _tmp35_;
	gchar* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->frame;
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	cur_child = _tmp2_;
	cur_width = 0;
	cur_height = 0;
	_tmp3_ = self->priv->frame;
	_tmp4_ = gtk_bin_get_child ((GtkBin*) _tmp3_);
	if (_tmp4_ != NULL) {
		GtkFrame* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp5_ = self->priv->frame;
		_tmp6_ = cur_child;
		gtk_container_remove ((GtkContainer*) _tmp5_, _tmp6_);
		_tmp7_ = cur_child;
		gtk_widget_get_size_request (_tmp7_, &_tmp8_, &_tmp9_);
		cur_width = _tmp8_;
		cur_height = _tmp9_;
	}
	_tmp10_ = self->priv->media;
	_tmp10__length1 = self->priv->media_length1;
	_tmp11_ = _tmp10_[new_index];
	_tmp12_ = _g_object_ref0 (_tmp11_);
	media = _tmp12_;
	new_widget = NULL;
	_tmp13_ = media;
	if (cb_media_is_video (_tmp13_)) {
		CbMedia* _tmp14_;
		GdkRectangle _tmp15_;
		CbMediaVideoWidget* _tmp16_;
		GtkFrame* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* _tmp19_;
		_tmp14_ = media;
		_tmp15_ = self->priv->max_dimensions;
		_tmp16_ = cb_media_video_widget_new (_tmp14_, &_tmp15_);
		g_object_ref_sink (_tmp16_);
		_g_object_unref0 (new_widget);
		new_widget = (GtkWidget*) _tmp16_;
		_tmp17_ = self->priv->frame;
		_tmp18_ = new_widget;
		gtk_container_add ((GtkContainer*) _tmp17_, _tmp18_);
		_tmp19_ = new_widget;
		cb_media_video_widget_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, CB_TYPE_MEDIA_VIDEO_WIDGET, CbMediaVideoWidget));
	} else {
		CbMedia* _tmp20_;
		GdkRectangle _tmp21_;
		CbMediaImageWidget* _tmp22_;
		GtkFrame* _tmp23_;
		GtkWidget* _tmp24_;
		_tmp20_ = media;
		_tmp21_ = self->priv->max_dimensions;
		_tmp22_ = cb_media_image_widget_new (_tmp20_, &_tmp21_);
		g_object_ref_sink (_tmp22_);
		_g_object_unref0 (new_widget);
		new_widget = (GtkWidget*) _tmp22_;
		_tmp23_ = self->priv->frame;
		_tmp24_ = new_widget;
		gtk_container_add ((GtkContainer*) _tmp23_, _tmp24_);
	}
	_tmp25_ = new_widget;
	gtk_widget_show_all (_tmp25_);
	_tmp26_ = new_widget;
	gtk_widget_get_size_request (_tmp26_, &_tmp27_, &_tmp28_);
	new_width = _tmp27_;
	new_height = _tmp28_;
	if (new_width != cur_width) {
		_tmp31_ = TRUE;
	} else {
		_tmp31_ = new_height != cur_height;
	}
	if (_tmp31_) {
		_tmp30_ = new_width > 0;
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		_tmp29_ = new_height > 0;
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		gtk_window_resize ((GtkWindow*) self, new_width, new_height);
	}
	gtk_widget_queue_resize ((GtkWidget*) self);
	self->priv->cur_index = new_index;
	_tmp32_ = self->priv->media_count;
	_tmp33_ = self->priv->media;
	_tmp33__length1 = self->priv->media_length1;
	_tmp34_ = self->priv->media;
	_tmp34__length1 = self->priv->media_length1;
	_tmp35_ = g_strdup_printf (ngettext ("Image %d of %d", "Image %d of %d", (gulong) _tmp33__length1), self->priv->cur_index + 1, _tmp34__length1);
	_tmp36_ = _tmp35_;
	gtk_label_set_text (_tmp32_, _tmp36_);
	_g_free0 (_tmp36_);
	_g_object_unref0 (new_widget);
	_g_object_unref0 (media);
	_g_object_unref0 (cur_child);
}

static void
media_dialog_next_media (MediaDialog* self)
{
	CbMedia** _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media;
	_tmp0__length1 = self->priv->media_length1;
	media_dialog_change_media (self, (self->priv->cur_index + 1) % _tmp0__length1);
}

static void
media_dialog_previous_media (MediaDialog* self)
{
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	if (self->priv->cur_index != 0) {
		_tmp0_ = self->priv->cur_index - 1;
	} else {
		CbMedia** _tmp1_;
		gint _tmp1__length1;
		_tmp1_ = self->priv->media;
		_tmp1__length1 = self->priv->media_length1;
		_tmp0_ = _tmp1__length1 - 1;
	}
	media_dialog_change_media (self, _tmp0_);
}

static gboolean
media_dialog_key_press_event_cb (MediaDialog* self,
                                 GdkEventKey* evt)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	if (evt->keyval == GDK_KEY_Left) {
		media_dialog_previous_media (self);
	} else {
		if (evt->keyval == GDK_KEY_Right) {
			media_dialog_next_media (self);
		} else {
			gtk_widget_destroy ((GtkWidget*) self);
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = media_dialog_key_press_event_cb ((MediaDialog*) self, event);
	return result;
}

static void
media_dialog_next_button_clicked_cb (MediaDialog* self)
{
	g_return_if_fail (self != NULL);
	media_dialog_next_media (self);
}

static void
_media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	media_dialog_next_button_clicked_cb ((MediaDialog*) self);
}

static void
media_dialog_previous_button_clicked_cb (MediaDialog* self)
{
	g_return_if_fail (self != NULL);
	media_dialog_previous_media (self);
}

static void
_media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	media_dialog_previous_button_clicked_cb ((MediaDialog*) self);
}

static gboolean
media_dialog_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->window;
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = event->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
		GtkRevealer* _tmp6_;
		_tmp4_ = self->priv->next_revealer;
		gtk_revealer_set_reveal_child (_tmp4_, TRUE);
		_tmp5_ = self->priv->previous_revealer;
		gtk_revealer_set_reveal_child (_tmp5_, TRUE);
		_tmp6_ = self->priv->media_count_revealer;
		gtk_revealer_set_reveal_child (_tmp6_, TRUE);
	}
	result = FALSE;
	return result;
}

static gboolean
media_dialog_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->window;
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = event->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
		GtkRevealer* _tmp6_;
		_tmp4_ = self->priv->next_revealer;
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
		_tmp5_ = self->priv->previous_revealer;
		gtk_revealer_set_reveal_child (_tmp5_, FALSE);
		_tmp6_ = self->priv->media_count_revealer;
		gtk_revealer_set_reveal_child (_tmp6_, FALSE);
	}
	result = FALSE;
	return result;
}

static void
media_dialog_class_init (MediaDialogClass * klass,
                         gpointer klass_data)
{
	media_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MediaDialog_private_offset);
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_enter_notify_event;
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_leave_notify_event;
	G_OBJECT_CLASS (klass)->finalize = media_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/media-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "frame", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, frame));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "next_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, next_revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "previous_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, previous_revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "media_count_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, media_count_revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "media_count", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, media_count));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_media_dialog_key_press_event_cb_gtk_widget_key_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "next_button_clicked_cb", G_CALLBACK(_media_dialog_next_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "previous_button_clicked_cb", G_CALLBACK(_media_dialog_previous_button_clicked_cb_gtk_button_clicked));
}

static void
media_dialog_instance_init (MediaDialog * self,
                            gpointer klass)
{
	self->priv = media_dialog_get_instance_private (self);
	self->priv->cur_index = 0;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
media_dialog_finalize (GObject * obj)
{
	MediaDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_DIALOG, MediaDialog);
	_g_object_unref0 (self->priv->button_gesture);
	G_OBJECT_CLASS (media_dialog_parent_class)->finalize (obj);
}

static GType
media_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaDialog), 0, (GInstanceInitFunc) media_dialog_instance_init, NULL };
	GType media_dialog_type_id;
	media_dialog_type_id = g_type_register_static (gtk_window_get_type (), "MediaDialog", &g_define_type_info, 0);
	MediaDialog_private_offset = g_type_add_instance_private (media_dialog_type_id, sizeof (MediaDialogPrivate));
	return media_dialog_type_id;
}

GType
media_dialog_get_type (void)
{
	static volatile gsize media_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&media_dialog_type_id__volatile)) {
		GType media_dialog_type_id;
		media_dialog_type_id = media_dialog_get_type_once ();
		g_once_init_leave (&media_dialog_type_id__volatile, media_dialog_type_id);
	}
	return media_dialog_type_id__volatile;
}

